Scriptname SPEAdaptationScript extends SPEPlayerOnlyAbility
{Turns waterbreathing into waterwalking.}

FormList Property SPEWaterbreathingEffects Auto
Spell Property SPEPerkAdaptationWaterwalking auto
MagicEffect currentEffect

Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
	If SPEWaterbreathingEffects.HasForm(akEffect)
		currentEffect = akEffect
		PlayerRef.AddSpell(SPEPerkAdaptationWaterwalking, false)
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Event OnUpdate()
	If PlayerRef.HasMagicEffect(currentEffect) == 0 ;effect has expired
		currentEffect = CheckForWaterbreathing()
		If currentEffect == NONE ;no other effects active
			PlayerRef.RemoveSpell(SPEPerkAdaptationWaterwalking)
		Else
			RegisterForSingleUpdate(1) ;effect found and stored, keep polling
		EndIf
	Else
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Event OnEffectStart(Actor akTarget, Actor akCaster)
	currentEffect = CheckForWaterbreathing()
	If currentEffect != NONE
		PlayerRef.AddSpell(SPEPerkAdaptationWaterwalking, false)
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	PlayerRef.RemoveSpell(SPEPerkAdaptationWaterwalking)
EndEvent

MagicEffect Function CheckForWaterbreathing()
	MagicEffect ActiveWaterbreathingEffect = NONE
	int i = SPEWaterbreathingEffects.GetSize()
	While i > 0
		i -= 1
		If PlayerRef.HasMagicEffect(SPEWaterbreathingEffects.GetAt(i) as MagicEffect)
			i = 0
			ActiveWaterBreathingEffect = SPEWaterbreathingEffects.GetAt(i) as MagicEffect
		EndIf
	EndWhile
	return ActiveWaterbreathingEffect
EndFunction