Scriptname SPEBashLocksScript extends SPEPlayerOnlyAbility
{Allows the player to bash locks.}

Sound Property SPEWPNImpactBlunt2HVsWood Auto
Sound Property WPNImpactBluntVsWood Auto
Keyword Property ArmorShield Auto
Spell Property SPEPerkBashLocksDetection01 Auto
Spell Property SPEPerkBashLocksDetection02 Auto
int BashLevel = 0
int LockLevel
ObjectReference LockedItem

Function Initialize()
	RegisterforCrosshairRef()
	SetBashLevel()
	RegisterForModEvent("SPE_LockBash", "OnBashWitnessed")
EndFunction

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Weapon || akBaseObject.HasKeyword(ArmorShield)
		SetBashLevel()
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Weapon || akBaseObject.HasKeyword(ArmorShield)
		SetBashLevel()
	EndIf
EndEvent

;Lock Levels:
;0 = Novice
;25 = Apprentice
;50 = Adept
;75 = Expert
;100 = Master
;255 = Requires Key

Function SetBashLevel()
	If PlayerRef.WornHasKeyword(ArmorShield)
		BashLevel = PlayerRef.GetEquippedShield().GetArmorRating() * 4
	Else
		Weapon CurrentWeapon = PlayerRef.GetEquippedWeapon()
		If CurrentWeapon != NONE
			BashLevel = CurrentWeapon.GetBaseDamage() * 8
		Else ;unarmed bash from a mod maybe?
			BashLevel = (PlayerRef.GetAV("UnarmedDamage") * 8) as int ;also figure torch
		EndIf
	EndIf
EndFunction

Event OnCrosshairRefChange(ObjectReference ref)
	If ref != NONE && ref.IsLocked()
		LockLevel = ref.GetLockLevel()
		If LockLevel <= 100
			LockedItem = ref
			GoToState("WatchingForBash")
			RegisterForSingleUpdate(0.1)
		EndIf
	Else
		GoToState("")
	EndIf
EndEvent

State WatchingForBash
	Event OnUpdate()
		If PlayerRef.GetAnimationVariableBool("IsBashing") == 1
			GoToState("ListeningForCrime")
			If LockLevel <= BashLevel
				LockedItem.CreateDetectionEvent(PlayerRef, 100)
				LockedItem.Lock(false)
				SPEPerkBashLocksDetection01.Cast(PlayerRef)
				Utility.Wait(0.2) ;let the animation play a bit
				int soundID = SPEWPNImpactBlunt2HVsWood.Play(LockedItem)
				Sound.SetInstanceVolume(soundID, 1.0)
			Else
				LockedItem.CreateDetectionEvent(PlayerRef, 10)
				SPEPerkBashLocksDetection02.Cast(PlayerRef)
				Utility.Wait(0.2) ;let the animation play a bit
				int soundID = WPNImpactBluntVsWood.Play(LockedItem)
				Sound.SetInstanceVolume(soundID, 1.0)
			EndIf
		Else
			RegisterForSingleUpdate(0.1)
		EndIf
	EndEvent
EndState

Function OnBashWitnessed(string eventName, string strArg, float numArg, Form sender)
	;Debug.Trace("Crime already reported.")
EndFunction

State ListeningForCrime
	Function OnBashWitnessed(string eventName, string strArg, float numArg, Form sender)
		GoToState("")
		;Debug.Trace("Bash witnessed!")
		(sender as Actor).SendAssaultAlarm()
	EndFunction
EndState
