Scriptname SPEBeginningQuestScript extends Quest  
{Used for resetting perks, applying debuffs, and recovering from those debuffs.}

;auto perks
FormList Property SPEAutoPerks Auto ;full list, now deprecated in favor of separate lists
FormList Property SPEAutoAlchemy Auto
FormList Property SPEAutoAlteration Auto
FormList Property SPEAutoArchery Auto
FormList Property SPEAutoBlock Auto
FormList Property SPEAutoConjuration Auto
FormList Property SPEAutoDestruction Auto
FormList Property SPEAutoEnchanting Auto
FormList Property SPEAutoHeavyArmor Auto
FormList Property SPEAutoIllusion Auto
FormList Property SPEAutoLightArmor Auto
FormList Property SPEAutoLockpicking Auto
FormList Property SPEAutoOneHanded Auto
FormList Property SPEAutoPickpocket Auto
FormList Property SPEAutoRestoration Auto
FormList Property SPEAutoSmithing Auto
FormList Property SPEAutoSneak Auto
FormList Property SPEAutoSpeech Auto
FormList Property SPEAutoTwoHanded Auto
GlobalVariable Property AutoPerkAlchemy Auto
GlobalVariable Property AutoPerkAlteration Auto
GlobalVariable Property AutoPerkArchery Auto
GlobalVariable Property AutoPerkBlock Auto
GlobalVariable Property AutoPerkConjuration Auto
GlobalVariable Property AutoPerkDestruction Auto
GlobalVariable Property AutoPerkEnchanting Auto
GlobalVariable Property AutoPerkHeavyArmor Auto
GlobalVariable Property AutoPerkIllusion Auto
GlobalVariable Property AutoPerkLightArmor Auto
GlobalVariable Property AutoPerkLockpicking Auto
GlobalVariable Property AutoPerkOneHanded Auto
GlobalVariable Property AutoPerkPickpocket Auto
GlobalVariable Property AutoPerkRestoration Auto
GlobalVariable Property AutoPerkSmithing Auto
GlobalVariable Property AutoPerkSneak Auto
GlobalVariable Property AutoPerkSpeech Auto
GlobalVariable Property AutoPerkTwoHanded Auto

;normal perks
FormList Property SPESpecPerks Auto ;full list, now deprecated in favor of separate lists
FormList Property SPESpecAlchemy Auto
FormList Property SPESpecAlteration Auto
FormList Property SPESpecArchery Auto
FormList Property SPESpecBlock Auto
FormList Property SPESpecConjuration Auto
FormList Property SPESpecDestruction Auto
FormList Property SPESpecEnchanting Auto
FormList Property SPESpecHeavyArmor Auto
FormList Property SPESpecIllusion Auto
FormList Property SPESpecLightArmor Auto
FormList Property SPESpecLockpicking Auto
FormList Property SPESpecOneHanded Auto
FormList Property SPESpecPickpocket Auto
FormList Property SPESpecRestoration Auto
FormList Property SPESpecSmithing Auto
FormList Property SPESpecSneak Auto
FormList Property SPESpecSpeech Auto
FormList Property SPESpecTwoHanded Auto
GlobalVariable Property SPEDisableAlchemy Auto
GlobalVariable Property SPEDisableAlteration Auto
GlobalVariable Property SPEDisableArchery Auto
GlobalVariable Property SPEDisableBlock Auto
GlobalVariable Property SPEDisableConjuration Auto
GlobalVariable Property SPEDisableDestruction Auto
GlobalVariable Property SPEDisableEnchanting Auto
GlobalVariable Property SPEDisableHeavyArmor Auto
GlobalVariable Property SPEDisableIllusion Auto
GlobalVariable Property SPEDisableLightArmor Auto
GlobalVariable Property SPEDisableLockpicking Auto
GlobalVariable Property SPEDisableOneHanded Auto
GlobalVariable Property SPEDisablePickpocket Auto
GlobalVariable Property SPEDisableRestoration Auto
GlobalVariable Property SPEDisableSmithing Auto
GlobalVariable Property SPEDisableSneak Auto
GlobalVariable Property SPEDisableSpeech Auto
GlobalVariable Property SPEDisableTwoHanded Auto

;other stuff
Keyword Property Vampire Auto
FormList Property SPEDamageHealthSpells Auto
FormList Property SPEDamageMagickaSpells Auto
FormList Property SPEDamageStaminaSpells Auto
GlobalVariable Property AutoPerk Auto
GlobalVariable Property RefundAutoPerks Auto
GlobalVariable Property SPEUninstall Auto
GlobalVariable Property SPEPerkResetPenalty Auto
GlobalVariable Property SPEMenuPerkReset Auto
Spell Property SPEBeginningShockSpell Auto
ObjectReference Property TeleportMarker Auto
ObjectReference Property BeginningStone Auto
ObjectReference Property ExitDoor Auto
Message Property SPEPerkResetStart Auto
Message Property SPEPerkResetFinish Auto
Actor Property PlayerRef Auto
int healthIndex
int magickaIndex
int staminaIndex

Event OnUpdate()
	;this block is called by the menu
	If SPEMenuPerkReset.GetValue() == 1
		SPEPerkResetStart.Show()
		ResetPerks()
	ElseIf SPEPerkResetPenalty.GetValue() == 0
		RemoveDebuffs()
	EndIf
EndEvent

Event OnUpdateGameTime()
	If PlayerRef.HasSpell(SPEDamageHealthSpells.GetAt(healthIndex) as Spell)
		PlayerRef.RemoveSpell(SPEDamageHealthSpells.GetAt(healthIndex) as Spell)
	EndIf
	If healthIndex ;don't add a spell if we just removed the last one
		healthIndex -= 1
		PlayerRef.AddSpell(SPEDamageHealthSpells.GetAt(healthIndex) as Spell, false)
		RegisterForSingleUpdateGameTime(24)
	EndIf
	If PlayerRef.HasSpell(SPEDamageMagickaSpells.GetAt(magickaIndex) as Spell)
		PlayerRef.RemoveSpell(SPEDamageMagickaSpells.GetAt(magickaIndex) as Spell)
	EndIf
	If magickaIndex ;don't add a spell if we just removed the last one
		magickaIndex -= 1
		PlayerRef.AddSpell(SPEDamageMagickaSpells.GetAt(magickaIndex) as Spell, false)
		RegisterForSingleUpdateGameTime(24)
	EndIf
	If PlayerRef.HasSpell(SPEDamageStaminaSpells.GetAt(staminaIndex) as Spell)
		PlayerRef.RemoveSpell(SPEDamageStaminaSpells.GetAt(staminaIndex) as Spell)
	EndIf
	If staminaIndex ;don't add a spell if we just removed the last one
		staminaIndex -= 1
		PlayerRef.AddSpell(SPEDamageStaminaSpells.GetAt(staminaIndex) as Spell, false)
		RegisterForSingleUpdateGameTime(24)
	EndIf
EndEvent

Function ResetPerks()

	Game.DisablePlayerControls(false, false) ;stop player from accessing the perk menu or reactivating the stone
	ExitDoor.Disable() ;make sure this doesn't cause problems
	
	RemoveDebuffs() ;Remove any debuff spells before calculating debuffs.

	If SPEUninstall.GetValue()
		Uninstall() ;quicker method of removing all perks without checking for globals
	Else
		int perkRefund = 0
		bool AutoRefund = RefundAutoPerks.GetValue() as bool
		
		;Perks that modify health/magicka/stamina can throw off calculations, so take care of trees with those first.
		If SPEDisablePickpocket.GetValue() == 0 ;check to make sure tree is enabled (not overwritten)
			perkRefund += RemovePerks(SPESpecPickpocket) ;remove perks, track refund
			If AutoPerk.GetValue() == 0 || AutoPerkPickpocket.GetValue() == 0 ;check to see if autoperk is off
				perkRefund += RemovePerks(SPEAutoPickpocket, AutoRefund) ;remove auto-perks with possible refund
			EndIf
		EndIf
		If SPEDisableConjuration.GetValue() == 0
			perkRefund += RemovePerks(SPESpecConjuration)
			If AutoPerk.GetValue() == 0 || AutoPerkConjuration.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoConjuration, AutoRefund)
			EndIf
		EndIf

		If SPEDisableSpeech.GetValue() == 0
			perkRefund += RemovePerks(SPESpecSpeech)
			If AutoPerk.GetValue() == 0 || AutoPerkSpeech.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoSpeech, AutoRefund)
			EndIf
		EndIf

		If SPEPerkResetPenalty.GetValue() == 1 ;penalties are needed
			;Calculate new debuffs. Roughly 40% of each stat (max 300), recovering 20 points per day (max 15 days).
			healthIndex = Math.Floor(PlayerRef.GetBaseAV("Health") * 0.4 / 20) - 1
			magickaIndex = Math.Floor(PlayerRef.GetBaseAV("Magicka") * 0.4 / 20) - 1
			staminaIndex = Math.Floor(PlayerRef.GetBaseAV("Stamina") * 0.4 / 20) - 1
			If healthIndex > 14
				healthIndex = 14
			EndIf
			If magickaIndex > 14
				magickaIndex = 14
			EndIf
			If staminaIndex > 14
				staminaIndex = 14
			EndIf
			
			;add new debuffs
			PlayerRef.AddSpell(SPEDamageHealthSpells.GetAt(healthIndex) as Spell, false)
			PlayerRef.AddSpell(SPEDamageMagickaSpells.GetAt(magickaIndex) as Spell, false)
			PlayerRef.AddSpell(SPEDamageStaminaSpells.GetAt(staminaIndex) as Spell, false)
			RegisterForSingleUpdateGametime(24) ;check back in a day
			
			;Now, apply spell effects. This has to be second to avoid strange bugs where the debuffs don't apply properly.
			
			If SPEMenuPerkReset.GetValue() == 0
				SPEBeginningShockSpell.Cast(BeginningStone, PlayerRef) ;then shock the player
				BeginningStone.PushActorAway(PlayerRef, 10) ;launch the player
				
				;apply damage for effect
				PlayerRef.DamageAV("Health", PlayerRef.GetAV("Health") - 1)
				PlayerRef.DamageAV("Magicka", PlayerRef.GetAV("Magicka") - 1)
				PlayerRef.DamageAV("Stamina", PlayerRef.GetAV("Stamina") - 1)
			EndIf
		EndIf
		
		;finally start resetting perks.
		If SPEDisableAlchemy.GetValue() == 0
			perkRefund += RemovePerks(SPESpecAlchemy)
			If AutoPerk.GetValue() == 0 || AutoPerkAlchemy.GetValue() == 0 
				perkRefund += RemovePerks(SPEAutoAlchemy, AutoRefund)
			EndIf
		EndIf
		If SPEDisableAlteration.GetValue() == 0
			perkRefund += RemovePerks(SPESpecAlteration)
			If AutoPerk.GetValue() == 0 || AutoPerkAlteration.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoAlteration, AutoRefund)
			EndIf
		EndIf
		If SPEDisableArchery.GetValue() == 0
			perkRefund += RemovePerks(SPESpecArchery)
			If AutoPerk.GetValue() == 0 || AutoPerkArchery.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoArchery, AutoRefund)
			EndIf
		EndIf
		If SPEDisableBlock.GetValue() == 0
			perkRefund += RemovePerks(SPESpecBlock)
			If AutoPerk.GetValue() == 0 || AutoPerkBlock.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoBlock, AutoRefund)
			EndIf
		EndIf
		If SPEDisableDestruction.GetValue() == 0
			perkRefund += RemovePerks(SPESpecDestruction)
			If AutoPerk.GetValue() == 0 || AutoPerkDestruction.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoDestruction, AutoRefund)
			EndIf
		EndIf
		If SPEDisableEnchanting.GetValue() == 0
			perkRefund += RemovePerks(SPESpecEnchanting)
			If AutoPerk.GetValue() == 0 || AutoPerkEnchanting.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoEnchanting, AutoRefund)
			EndIf
		EndIf
		If SPEDisableHeavyArmor.GetValue() == 0
			perkRefund += RemovePerks(SPESpecHeavyArmor)
			If AutoPerk.GetValue() == 0 || AutoPerkHeavyArmor.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoHeavyArmor, AutoRefund)
			EndIf
		EndIf
		If SPEDisableIllusion.GetValue() == 0
			perkRefund += RemovePerks(SPESpecIllusion)
			If AutoPerk.GetValue() == 0 || AutoPerkIllusion.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoIllusion, AutoRefund)
			EndIf
		EndIf
		If SPEDisableLightArmor.GetValue() == 0
			perkRefund += RemovePerks(SPESpecLightArmor)
			If AutoPerk.GetValue() == 0 || AutoPerkLightArmor.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoLightArmor, AutoRefund)
			EndIf
		EndIf
		If SPEDisableLockpicking.GetValue() == 0
			perkRefund += RemovePerks(SPESpecLockpicking)
			If AutoPerk.GetValue() == 0 || AutoPerkLockpicking.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoLockpicking, AutoRefund)
			EndIf
		EndIf
		If SPEDisableOneHanded.GetValue() == 0
			perkRefund += RemovePerks(SPESpecOneHanded)
			If AutoPerk.GetValue() == 0 || AutoPerkOneHanded.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoOneHanded, AutoRefund)
			EndIf
		EndIf
		If SPEDisableRestoration.GetValue() == 0
			perkRefund += RemovePerks(SPESpecRestoration)
			If AutoPerk.GetValue() == 0 || AutoPerkRestoration.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoRestoration, AutoRefund)
			EndIf
		EndIf
		If SPEDisableSmithing.GetValue() == 0
			perkRefund += RemovePerks(SPESpecSmithing)
			If AutoPerk.GetValue() == 0 || AutoPerkSmithing.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoSmithing, AutoRefund)
			EndIf
		EndIf
		If SPEDisableSneak.GetValue() == 0
			perkRefund += RemovePerks(SPESpecSneak)
			If AutoPerk.GetValue() == 0 || AutoPerkSneak.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoSneak, AutoRefund)
			EndIf
		EndIf
		If SPEDisableTwoHanded.GetValue() == 0
			perkRefund += RemovePerks(SPESpecTwoHanded)
			If AutoPerk.GetValue() == 0 || AutoPerkTwoHanded.GetValue() == 0
				perkRefund += RemovePerks(SPEAutoTwoHanded, AutoRefund)
			EndIf
		EndIf
		
		;now set the appropriate number of perk points
		Game.ModPerkPoints(perkRefund)
	
	EndIf
		
	
	;return player control
	Game.EnablePlayerControls()
	If SPEMenuPerkReset.GetValue() == 0 && !PlayerRef.HasKeyword(Vampire) && SPEUninstall.GetValue() == 0 ;don't warp cases
		PlayerRef.MoveTo(TeleportMarker)
	EndIf

	ExitDoor.Enable() ;Make sure it's possible to exit
	
	If SPEMenuPerkReset.GetValue() == 1
		SPEPerkResetFinish.Show()
		SPEMenuPerkReset.SetValue(0) ;re-initialize for next time
	EndIf
		
EndFunction

int Function RemovePerks(Formlist PerkList, bool Refund = true)
	int refundAmount = 0
	int listIndex = PerkList.GetSize()
	If Refund
		While listIndex > 0
			listIndex -= 1
			If PlayerRef.HasPerk(PerkList.GetAt(listIndex) as Perk)
				PlayerRef.RemovePerk(PerkList.GetAt(listIndex) as Perk)
				refundAmount += 1
			EndIf
		EndWhile
	Else
		While listIndex > 0
			listIndex -= 1
			PlayerRef.RemovePerk(PerkList.GetAt(listIndex) as Perk)
		EndWhile
	EndIf
	return refundAmount
EndFunction

Function RemoveDebuffs()
	int spellIndex = SPEDamageHealthSpells.GetSize()
	While spellIndex > 0
		spellIndex -= 1
		PlayerRef.RemoveSpell(SPEDamageHealthSpells.GetAt(spellIndex) as Spell)
		PlayerRef.RemoveSpell(SPEDamageMagickaSpells.GetAt(spellIndex) as Spell)
		PlayerRef.RemoveSpell(SPEDamageStaminaSpells.GetAt(spellIndex) as Spell)
		healthIndex = 0
		magickaIndex = 0
		staminaIndex = 0
	EndWhile
EndFunction

Function Uninstall()
	RemovePerks(SPESpecAlchemy, false)
	RemovePerks(SPEAutoAlchemy, false)
	RemovePerks(SPESpecAlteration, false)
	RemovePerks(SPEAutoAlteration, false)
	RemovePerks(SPESpecArchery, false)
	RemovePerks(SPEAutoArchery, false)
	RemovePerks(SPESpecBlock, false)
	RemovePerks(SPEAutoBlock, false)
	RemovePerks(SPESpecConjuration, false)
	RemovePerks(SPEAutoConjuration, false)
	RemovePerks(SPESpecDestruction, false)
	RemovePerks(SPEAutoDestruction, false)
	RemovePerks(SPESpecEnchanting, false)
	RemovePerks(SPEAutoEnchanting, false)
	RemovePerks(SPESpecHeavyArmor, false)
	RemovePerks(SPEAutoHeavyArmor, false)
	RemovePerks(SPESpecIllusion, false)
	RemovePerks(SPEAutoIllusion, false)
	RemovePerks(SPESpecLightArmor, false)
	RemovePerks(SPEAutoLightArmor, false)
	RemovePerks(SPESpecLockpicking, false)
	RemovePerks(SPEAutoLockpicking, false)
	RemovePerks(SPESpecOneHanded, false)
	RemovePerks(SPEAutoOneHanded, false)
	RemovePerks(SPESpecPickpocket, false)
	RemovePerks(SPEAutoPickpocket, false)
	RemovePerks(SPESpecRestoration, false)
	RemovePerks(SPEAutoRestoration, false)
	RemovePerks(SPESpecSmithing, false)
	RemovePerks(SPEAutoSmithing, false)
	RemovePerks(SPESpecSneak, false)
	RemovePerks(SPEAutoSneak, false)
	RemovePerks(SPESpecSpeech, false)
	RemovePerks(SPEAutoSpeech, false)
	RemovePerks(SPESpecTwoHanded, false)
	RemovePerks(SPEAutoTwoHanded, false)
	Game.SetPerkPoints(PlayerRef.GetLevel() - 1)
EndFunction