Scriptname SPEBestFriendQuestScript extends Quest Conditional
{Script that handles pet summoning and unsummoning.}

Perk Property SPEBestFriend Auto
SPEBestFriendPetScript Property CurrentPetAlias Auto
ReferenceAlias Property CustomNameAlias Auto
ReferenceAlias Property HomeAlias Auto
ReferenceAlias Property TalkingAlias Auto
TalkingActivator Property SPEBF_PetDialogueActivator Auto
ActorBase[] Property SPEBF_Pets Auto
GlobalVariable Property SPEBF_PetType Auto
GlobalVariable Property SPEBF_UseCustomName Auto
GlobalVariable Property SPEBF_TrackPet Auto
GlobalVariable Property SPEBF_Home Auto
Actor Property PlayerRef Auto
LocationAlias Property LastTownAlias Auto
Keyword Property LocTypeHabitationHasInn Auto
Actor CurrentPet

Function SetPet()
	CurrentPet = PlayerRef.PlaceAtMe(SPEBF_Pets[SPEBF_PetType.GetValue() as int]) as Actor
	CurrentPetAlias.ForceRefTo(CurrentPet)
	TalkingAlias.ForceRefTo(CurrentPet.PlaceAtMe(SPEBF_PetDialogueActivator, abInitiallyDisabled = true))
	If SPEBF_UseCustomName.GetValue() == 1
		CustomNameAlias.ForceRefTo(CurrentPet)
	EndIf
	CurrentPetAlias.PetInit()
	Location CurrentLocation = PlayerRef.GetCurrentLocation()
	If CurrentLocation != NONE && CurrentLocation.HasKeyword(LocTypeHabitationHasInn)
		LastTownAlias.ForceLocationTo(PlayerRef.GetCurrentLocation())
	EndIf
EndFunction

Function ClearPet()
	Actor SadPet = CurrentPetAlias.GetActorRef()
	If SadPet != NONE
		SadPet.StopCombatAlarm()
		SadPet.SetPlayerTeammate(false)
		SadPet.SetAV("WaitingForPlayer", 0)	
		SadPet.RemoveAllItems(PlayerRef, true, true)
		SadPet.Disable()
		SadPet.Delete() ;goodbye my friend
		CurrentPetAlias.Clear()
	EndIf
EndFunction

Event OnUpdate() ;process options after the menu is closed

	;first, handle the pet summoning
	CurrentPet = CurrentPetAlias.GetActorRef()
	If PlayerRef.HasPerk(SPEBestFriend) == 0
		RemovePet() ;perform quest shutdown
	Else ;player should have a pet
	
		;start the quest if needed
		If (self as Quest).IsRunning() == false
			(self as Quest).Start()
		EndIf
		
		;check pet status
		If CurrentPet == NONE ;summon new pet
			SetPet()
		ElseIf CurrentPet.GetActorBase() != SPEBF_Pets[SPEBF_PetType.GetValue() as int] || \
		SPEBF_UseCustomName.GetValue() != (CurrentPet == CustomNameAlias.GetActorRef()) ;changed pet type or display name
			ClearPet()
			SetPet()
		EndIf
		
		;check for pet tracking
		If SPEBF_TrackPet.GetValue() == 1
			SetObjectiveDisplayed(10)
		Else
			SetObjectiveDisplayed(10, false)
		EndIf
	EndIf
EndEvent

Function RemovePet()
	If CurrentPetAlias.GetActorRef() != NONE
		ClearPet()
	EndIf
	ObjectReference HomeRef = HomeAlias.GetRef()
	If HomeRef != NONE
		HomeAlias.GetRef().Disable()
		HomeAlias.GetRef().Delete()
		HomeAlias.Clear()
		SPEBF_Home.SetValue(0)
	EndIf
	ObjectReference DialogueActivator = TalkingAlias.GetRef()
	If DialogueActivator != NONE
		DialogueActivator.Delete()
	EndIf
	SetObjectiveDisplayed(10, false)
	(self as Quest).Reset()
	(self as Quest).Stop()
EndFunction