Scriptname SPEBrawlManager extends Quest  
{Handles entering and exiting "brawl mode".}

Quest Property DGIntimidateQuest Auto
Quest Property C00 Auto
GlobalVariable Property SPEBrawlMode Auto
GlobalVariable Property SPEUnarmed Auto
GlobalVariable Property SPEAutoBrawl Auto

Event OnInit()
	If SPEUnarmed.GetValue() == 0 ;no unarmed detection, poll instead
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Event OnUpdate()
	If SPEBrawlMode.GetValue() == 1
		RegisterForSingleUpdate(1) ;Poll during manual brawl mode.
	ElseIf SPEAutoBrawl.GetValue() == 1
		If CheckForBrawl() == 0
			StopBrawl()
		Else
			RegisterForSingleUpdate(1)
		EndIf
	ElseIf SPEUnarmed.GetValue() == 0 ;polling, because unarmed may not notify us
		If CheckForBrawl() == 0
			RegisterForSingleUpdate(1)
		EndIf
	EndIf
EndEvent

Function StartBrawl()
	;Warning: This script won't run during manual brawl mode. If other scripts need to disable themselves during a brawl, that code needs to run on those scripts themselves.
	SPEAutoBrawl.SetValue(1)
	RegisterForSingleUpdate(1)
EndFunction

Function StopBrawl()
	;Warning: This block won't run during manual brawl mode. If other scripts need to re-initialize themselves after a brawl ends, that code needs to run on those scripts themselves.
	SPEAutoBrawl.SetValue(0)
	If SPEUnarmed.GetValue() == 0 ;no unarmed, so go back to polling
		RegisterForSingleUpdate(1)
	Else
		;UnarmedAlias.RegisterForSingleUpdate(0) ;re-equips unarmed weapon, if appropriate
		(self as Quest).SendModEvent("SPE_EquipUnarmed")
	EndIf
EndFunction

int Function CheckForBrawl()
	If DGIntimidateQuest.IsRunning() || DGIntimidateQuest.IsStarting()
		If SPEAutoBrawl.GetValue() == 0 ;protect against redundant calls
			StartBrawl()
		EndIf
		Return 1
	ElseIf C00.GetStage() == 20
		If SPEAutoBrawl.GetValue() == 0 ;protect against redundant calls
			StartBrawl()
		EndIf
		Return 1
	Else
		SPEAutoBrawl.SetValue(0) ;just in case this isn't properly reset somehow, make sure it can fix itself
		Return 0
	EndIf
EndFunction
