Scriptname SPEChainCastingScript extends SPEPlayerOnlyAbility
{Manages the buffs for the chain casting effect.}

GlobalVariable Property SPEIsDualCasting Auto
Spell Property SPEPerkChainCastingAb01 Auto
Spell Property SPEPerkChainCastingAb02 Auto
Spell Property SPEPerkChainCastingAb03 Auto
Spell Property SPEPerkChainFinisherSpell Auto
EffectShader Property EnchBlueFXShader auto
MagicEffect Property SPEPerkChainCastingFinisherEffect Auto
Keyword Property MagicShout Auto

Event OnSpellCast(Form akSpell)
	Spell spellCast = akSpell as Spell
	If spellCast && !spellCast.HasKeyword(MagicShout) ;make sure it's a spell, not shouts or alchemy
		If PlayerRef.HasSpell(SPEPerkChainCastingAb03) && SPEIsDualCasting.GetValue() == 1
			EnchBlueFXShader.Stop(PlayerRef)
			PlayerRef.RemoveSpell(SPEPerkChainCastingAb03)
			SPEPerkChainFinisherSpell.Cast(PlayerRef)
		ElseIf PlayerRef.HasSpell(SPEPerkChainCastingAb02)
			EnchBlueFXShader.Play(PlayerRef)
			PlayerRef.AddSpell(SPEPerkChainCastingAb03, false)
			PlayerRef.RemoveSpell(SPEPerkChainCastingAb02)
		ElseIf PlayerRef.HasSpell(SPEPerkChainCastingAb01)
			PlayerRef.AddSpell(SPEPerkChainCastingAb02, false)
			PlayerRef.RemoveSpell(SPEPerkChainCastingAb01)
		ElseIf !PlayerRef.HasSpell(SPEPerkChainCastingAb03) && !PlayerRef.HasMagicEffect(SPEPerkChainCastingfinisherEffect)
			PlayerRef.AddSpell(SPEPerkChainCastingAb01, false)
		EndIf
		RegisterForSingleUpdate(6)
	EndIf
EndEvent

Event OnUpdate()
	PlayerRef.RemoveSpell(SPEPerkChainCastingAb01)
	PlayerRef.RemoveSpell(SPEPerkChainCastingAb02)
	PlayerRef.RemoveSpell(SPEPerkChainCastingAb03)
	EnchBlueFXShader.Stop(PlayerRef)
EndEvent
