Scriptname SPEConfigMenuScript extends SKI_ConfigBase
{Config menu script for SPERG}

;EXTERNAL SCRIPTS AND PROPERTIES
SPEUpdateScript Property SPEUpdateQuest Auto
SPEBeginningQuestScript Property SPEBeginningQuest Auto
SPESummonManagerScript Property SPESummonQuest Auto
SPESkillUp Property SPESkillUpQuest Auto
Quest Property SPEBestFriendQuest Auto
Actor Property PlayerRef Auto

;TOGGLE OPTION VARIABLES
GlobalVariable Property SPEBrawlMode Auto
int brawlModeOID_B
bool brawlModeState = false

GlobalVariable Property SPEMenuPerkReset Auto
int perkResetOID_B
bool perkResetState = false

GlobalVariable Property SPEPerkResetPenalty Auto
int resetPenaltyOID_B
bool resetPenaltyState = true

GlobalVariable Property SPEUninstall Auto
int uninstallOID_B
bool uninstallState = false

GlobalVariable Property SPEEtherealArrowsRequired Auto
int etherealReqOID_B
bool etherealReqState = true

GlobalVariable Property SPEMelting Auto
int meltingOID_B
bool meltingState = true

GlobalVariable Property SPEQuestRewards Auto
int questRewardOID_B
bool questRewardState = true

GlobalVariable Property SPELegendarySkills Auto
int legendarySkillOID_B
bool legendarySkillState = true

GlobalVariable Property SPEUnarmedDamage Auto
int unarmedDamageOID_B
bool unarmedDamageState = true

GlobalVariable Property RefundAutoPerks Auto
int refundAutoOID_B
bool refundAutoState = false

GlobalVariable Property SPECriticalFix Auto
int critFixOID_B
bool critFixState = true

Perk Property SPEBaseStaffManager Auto
int staffFixOID_B
bool staffFixState = true

GlobalVariable Property SPEFixNecromage Auto
int fixNecromageOID_B
bool fixNecromageState = false

GlobalVariable Property SPEShoutExp Auto
int shoutExpOID_B
bool shoutExpState = true

GlobalVariable Property SPEIngredientExp Auto
int ingredientExpOID_B
bool ingredientExpState = true

GlobalVariable Property SPEPotionExp Auto
int potionExpOID_B
bool potionExpState = true

GlobalVariable Property SPE2hSneakAttack Auto
int THSneakOID_B
bool THSneakState = true

GlobalVariable Property SPEHardcoreMode Auto
int hardcoreOID_B
bool hardcoreState = false

GlobalVariable Property SPELabelEnchantingDefault Auto
int labelEnchantingOID_B
bool labelEnchantingState = true

GlobalVariable Property SPELabelAlchemyDefault Auto
int labelAlchemyOID_B
bool labelAlchemyState = true

Perk Property SPEBaseBoundSpells Auto
int boundSpellsOID_B
bool boundSpellsState = true

Perk Property SPEBaseWardSpells Auto
GlobalVariable Property SPEWardSpells Auto
int wardSpellsOID_B
bool wardSpellsState = true

GlobalVariable Property SPEResetAliases Auto
int resetAliasesOID_B
bool resetAliasesState = false

GlobalVariable Property SPEBF_SimpleSelling Auto
int bfSellingOID_B
bool bfSellingState = false

GlobalVariable Property SPEBF_TrackPet Auto
int bfTrackOID_B
bool bfTrackState = false

GlobalVariable Property SPEBF_UseCustomName Auto
int bfNameOID_B
bool bfNameState = false

GlobalVariable Property SPEFixImpact Auto
int fixImpactOID_B
bool fixImpactState = true

GlobalVariable Property SPEWaxKey Auto
int waxKeyOID_B
bool waxKeyState = false

GlobalVariable Property SPEUseCustomAARace Auto
int useCustomAAOID_B
bool useCustomAAState = false

GlobalVariable Property SPEGoodListenerCostMode Auto
int GLCostOID_B
bool GLCostState = false

GlobalVariable Property SPECheckAuto Auto
int checkAutoOID_B
bool checkAutoState = false

GlobalVariable Property SPEDisableMagicScaling Auto
int DisableMagicScalingOID_B
bool DisableMagicScalingState = false

int advancedEnableOID_B
bool advancedEnabled = false

int disableTreesEnableOID_B
bool disableTreesEnabled = false


;MENU OPTION VARIABLES
GlobalVariable Property SPEWeaponSpeed Auto
int weaponSpeedOID_M
string[] weaponSpeedMode
int weaponSpeedIndex = 1

GlobalVariable Property SPESunderMode Auto
int sunderOID_M
string[] sunderList
int sunderIndex = 2

GlobalVariable Property AutoPerk Auto
int autoPerkOID_M
int autoPerkGeneralOID_M
string[] autoPerkList
int autoPerkIndex = 1

GlobalVariable Property SPECustomAARace Auto
int customAARaceOID_M
string[] customAARaceList
int customAARaceIndex = 6

GlobalVariable Property SPESummonMode Auto
int summonModeOID_M
string[] summonList
int summonIndex = 1

GlobalVariable Property SPEFrostAuraMode Auto
int frostAuraOID_M
string[] frostAuraList
int frostAuraIndex = 1

GlobalVariable Property SPEIllusionChargeMode Auto
int illusionChargeOID_M
string[] illusionChargeList
int illusionChargeIndex = 1

GlobalVariable Property SPEEtherealAmmoMode Auto
int etherealAmmoOID_M
string[] etherealAmmoList
int etherealAmmoIndex = 1

GlobalVariable Property SPEFoodExpMode Auto
int foodExpOID_M
string[] foodExpList
int foodExpIndex = 1

GlobalVariable Property SPEUnarmed Auto
int unarmedOID_M
string[] unarmedList
int unarmedIndex = 1

GlobalVariable Property SPEBF_PetType Auto
GlobalVariable Property SPEDawnguardLoaded Auto
GlobalVariable Property SPEDragonbornLoaded Auto
int bfTypeOID_M
string[] bfTypeList
string[] bfTypesNoDLC
string[] bfTypesDG
string[] bfTypesDB
string[] bfTypesAllDLC
int Property bfTypeIndex = 2 Auto

;SLIDER OPTION VARIABLES
GlobalVariable Property SPEWeaponSpeedTolerance Auto
int speedToleranceOID_S
float tolerance = 1.0
int setPerksOID_S
float perkPoints = 0.0
GlobalVariable Property SPEArmorExp Auto
int armorExpOID_S
float armorExpInterval = 6.0


;KEY OPTION VARIABLES
int summonKeyOID_K
int summonKey = 78
int ammoKeyOID_K
int ammoKey = 74


;TEXT OPTION VARIABLES
int versionNumberOID_T
string SPERGVersion = "4.0"

;FLAGS
int advancedFlag
int disableTreesFlag
int AutoPerkFlag

;MISC
Message Property SPEPerkResetMessage Auto
bool firstInit = true
string LastPage = "$SPE_General"

; SCRIPT VERSION
int function GetVersion()
	return 5 ;increment this number when adjusting anything in OnConfigInit()
endFunction

Event OnConfigInit()
	weaponSpeedMode = new string[4]
	weaponSpeedMode[0] = "$SPE_Disabled"
	weaponSpeedMode[1] = "$SPE_Automatic"
	weaponSpeedMode[2] = "$SPE_On"
	weaponSpeedMode[3] = "$SPE_Off"
	
	sunderList = new string[3]
	sunderList[0] = "$SPE_Off"
	sunderList[1] = "$SPE_Shield Only"
	sunderList[2] = "$SPE_On"
	
	autoPerkList = new string[3]
	autoPerkList[0] = "$SPE_Off"
	autoPerkList[1] = "$SPE_On"
	autoPerkList[2] = "$SPE_By Skill"
	
	customAARaceList = new string[10]
	customAARaceList[0] = "$SPE_Argonian"
	customAARaceList[1] = "$SPE_Breton"
	customAARaceList[2] = "$SPE_DarkElf"
	customAARaceList[3] = "$SPE_HighElf"
	customAARaceList[4] = "$SPE_Imperial"
	customAARaceList[5] = "$SPE_Khajiit"
	customAARaceList[6] = "$SPE_Nord"
	customAARaceList[7] = "$SPE_Orc"
	customAARaceList[8] = "$SPE_Redguard"
	customAARaceList[9] = "$SPE_WoodElf"
	
	summonList = new string[4]
	summonList[0] = "$SPE_Disabled"
	summonList[1] = "$SPE_On Combat"
	summonList[2] = "$SPE_Not Sneaking"
	summonList[3] = "$SPE_Manual"
	
	frostAuraList = new string[3]
	frostAuraList[0] = "$SPE_Disabled"
	frostAuraList[1] = "$SPE_Cloak"
	frostAuraList[2] = "$SPE_On Hit"
	
	illusionChargeList = new string[3]
	illusionChargeList[0] = "$SPE_Off"
	illusionChargeList[1] = "$SPE_Duration"
	illusionChargeList[2] = "$SPE_Magnitude"
	
	etherealAmmoList = new string[3]
	etherealAmmoList[0] = "$SPE_Disabled"
	etherealAmmoList[1] = "$SPE_Automatic"
	etherealAmmoList[2] = "$SPE_Manual"
	
	foodExpList = new string[3]
	foodExpList[0] = "$SPE_Disabled"
	foodExpList[1] = "$SPE_Stat Gain"
	foodExpList[2] = "$SPE_Alchemy Gain"
	
	unarmedList = new string[4]
	unarmedList[0] = "$SPE_Disabled"
	unarmedList[1] = "$SPE_Automatic"
	unarmedList[2] = "$SPE_Hotkey"
	unarmedList[3] = "$SPE_Manual"
	
	bfTypesNoDLC = new string[9]
	bfTypesNoDLC[0] = "$SPE_Baby Mammoth"
	bfTypesNoDLC[1] = "$SPE_Bear"
	bfTypesNoDLC[2] = "$SPE_Dog"
	bfTypesNoDLC[3] = "$SPE_Dwarven Spider"
	bfTypesNoDLC[4] = "$SPE_Frostbite Spider"
	bfTypesNoDLC[5] = "$SPE_Horker"
	bfTypesNoDLC[6] = "$SPE_Mudcrab"
	bfTypesNoDLC[7] = "$SPE_Sabre Cat"
	bfTypesNoDLC[8] = "$SPE_Wolf"
	
	bfTypesDG = new string[11]
	bfTypesDG[0] = "$SPE_Baby Mammoth"
	bfTypesDG[1] = "$SPE_Bear"
	bfTypesDG[2] = "$SPE_Dog"
	bfTypesDG[3] = "$SPE_Dwarven Spider"
	bfTypesDG[4] = "$SPE_Frostbite Spider"
	bfTypesDG[5] = "$SPE_Horker"
	bfTypesDG[6] = "$SPE_Mudcrab"
	bfTypesDG[7] = "$SPE_Sabre Cat"
	bfTypesDG[8] = "$SPE_Wolf"
	bfTypesDG[9] = "$SPE_Death Hound"
	bfTypesDG[10] = "$SPE_Husky"

	bfTypesDB = new string[11]
	bfTypesDB[0] = "$SPE_Baby Mammoth"
	bfTypesDB[1] = "$SPE_Bear"
	bfTypesDB[2] = "$SPE_Dog"
	bfTypesDB[3] = "$SPE_Dwarven Spider"
	bfTypesDB[4] = "$SPE_Frostbite Spider"
	bfTypesDB[5] = "$SPE_Horker"
	bfTypesDB[6] = "$SPE_Mudcrab"
	bfTypesDB[7] = "$SPE_Sabre Cat"
	bfTypesDB[8] = "$SPE_Wolf"
	bfTypesDB[9] = "$SPE_Bristleback"
	bfTypesDB[10] = "$SPE_Netch Calf"
	
	bfTypesAllDLC = new string[13]
	bfTypesAllDLC[0] = "$SPE_Baby Mammoth"
	bfTypesAllDLC[1] = "$SPE_Bear"
	bfTypesAllDLC[2] = "$SPE_Dog"
	bfTypesAllDLC[3] = "$SPE_Dwarven Spider"
	bfTypesAllDLC[4] = "$SPE_Frostbite Spider"
	bfTypesAllDLC[5] = "$SPE_Horker"
	bfTypesAllDLC[6] = "$SPE_Mudcrab"
	bfTypesAllDLC[7] = "$SPE_Sabre Cat"
	bfTypesAllDLC[8] = "$SPE_Wolf"
	bfTypesAllDLC[9] = "$SPE_Death Hound"
	bfTypesAllDLC[10] = "$SPE_Husky"
	bfTypesAllDLC[11] = "$SPE_Bristleback"
	bfTypesAllDLC[12] = "$SPE_Netch Calf"

	Pages = new string[5]
	Pages[0] = "$SPE_General"
	Pages[1] = "$SPE_Fixes & Compatibility"
	Pages[2] = "$SPE_Perk Settings"
	Pages[3] = "$SPE_Skill Settings"
	Pages[4] = "$SPE_Advanced"
	
	If firstInit
		firstInit = false
		advancedFlag = OPTION_FLAG_DISABLED
		AutoPerkFlag = OPTION_FLAG_NONE
		ToggleTreeFlags(false, true, false)
		ToggleTreeFlags(false, false, false)
	EndIf
EndEvent

Event OnConfigClose()
	If checkAutoState == true
		SPESkillUpQuest.AutoPerk()
	EndIf
EndEvent

Event OnPageReset(string page)
	{Called when a new page is selected, including the initial empty page}

	If page == ""
		page = LastPage
	Else
		LastPage = page
	EndIf
	InitializeMenu()
	SetCursorFillMode(TOP_TO_BOTTOM)
	
	If (page == "$SPE_General")
		AddHeaderOption("$SPE_Preferences")
		meltingOID_B = AddToggleOption("$SPE_Enable Salvage", meltingState)
		questRewardOID_B = AddToggleOption("$SPE_Quest Rewards", questRewardState)

		AddEmptyOption()
		autoPerkGeneralOID_M = AddMenuOption("$SPE_Auto Perk", autoPerkList[autoPerkIndex], AutoPerkFlag)
		refundAutoOID_B = AddToggleOption("$SPE_Refund Auto Perks", refundAutoState)
		resetPenaltyOID_B = AddToggleOption("$SPE_Perk Reset Penalty", resetPenaltyState)

		AddEmptyOption()
		perkResetOID_B = AddToggleOption("$SPE_Reset Perks", perkResetState)
		
		SetCursorPosition(1) ;right column
		AddHeaderOption("$SPE_Alternate Advancement")
		staffFixOID_B = AddToggleOption("$SPE_Staff Leveling", staffFixState)
		shoutExpOID_B = AddToggleOption("$SPE_Shout Leveling", shoutExpState)
		ingredientExpOID_B = AddToggleOption("$SPE_Ingredient Leveling", ingredientExpState)
		potionExpOID_B = AddToggleOption("$SPE_Potion Leveling", potionExpState)
		armorExpOID_S = AddSliderOption("$SPE_Armor Leveling", armorExpInterval, "{0}")
		foodExpOID_M = AddMenuOption("$SPE_Food Leveling", foodExpList[foodExpIndex])

		SetCursorPosition(23)
		versionNumberOID_T = AddTextOption("$SPE_SPERG Version", SPERGVersion, OPTION_FLAG_DISABLED)
		
	ElseIf (page == "$SPE_Fixes & Compatibility")
		AddHeaderOption("$SPE_Fixes")
		brawlModeOID_B = AddToggleOption("$SPE_Brawl Mode", brawlModeState)
		legendarySkillOID_B = AddToggleOption("$SPE_Legendary Skill Tracking", legendarySkillState)
		critFixOID_B = AddToggleOption("$SPE_Fix Critical Damage", critFixState)
		fixNecromageOID_B = AddToggleOption("$SPE_Fix Necromage", fixNecromageState)
		fixImpactOID_B = AddToggleOption("$SPE_Fix Impact", fixImpactState)
		checkAutoOID_B = AddToggleOption("$SPE_Check Auto Perks", checkAutoState)
		
		SetCursorPosition(1) ;right column
		AddHeaderOption("$SPE_Compatibility")
		unarmedOID_M = AddMenuOption("$SPE_Unarmed Mode", unarmedList[unarmedIndex])
		unarmedDamageOID_B = AddToggleOption("$SPE_Unarmed Damage Bonus", unarmedDamageState)
		boundSpellsOID_B = AddToggleOption("$SPE_Use Bound Spells", boundSpellsState)
		wardSpellsOID_B = AddToggleOption("$SPE_Use Ward Spells", wardSpellsState)
		DisableMagicScalingOID_B = AddToggleOption("$SPE_Disable Magic Scaling", DisableMagicScalingState)
		
	ElseIf (page == "$SPE_Perk Settings")
		sunderOID_M = AddMenuOption("$SPE_Sunder Armor", sunderList[sunderIndex])
		customAARaceOID_M = AddMenuOption("$SPE_AARace", customAARaceList[customAARaceIndex])
		useCustomAAOID_B = AddToggleOption("$SPE_Use Custom Race", useCustomAAState)
		frostAuraOID_M = AddMenuOption("$SPE_Frost Aura Mode", frostAuraList[frostAuraIndex])
		illusionChargeOID_M = AddMenuOption("$SPE_Illusion Charge Mode", illusionChargeList[illusionChargeIndex])
		THSneakOID_B = AddToggleOption("$SPE_Two-Handed Sneak Attacks", THSneakState)
		waxKeyOID_B = AddToggleOption("$SPE_Use Wax Key", waxKeyState)
		GLCostOID_B = AddToggleOption("$SPE_Good Listener Cost Mode", GLCostState)

		SetCursorPosition(1) ;right column
		bfTypeOID_M = AddMenuOption("$SPE_Best Friend Type", bfTypeList[bfTypeIndex])
		bfSellingOID_B = AddToggleOption("$SPE_Simple Selling", bfSellingState)
		bfTrackOID_B = AddToggleOption("$SPE_Track Pet", bfTrackState)

		AddEmptyOption()
		summonModeOID_M = AddMenuOption("$SPE_Summon Mode", summonList[summonIndex])
		summonKeyOID_K = AddKeyMapOption("$SPE_Summon Key", summonKey)
		
		AddEmptyOption()
		etherealAmmoOID_M = AddMenuOption("$SPE_Ethereal Arrow Mode", etherealAmmoList[etherealAmmoIndex])
		ammoKeyOID_K = AddKeyMapOption("$SPE_Ammo Key", ammoKey)

	ElseIf (page == "$SPE_Skill Settings")
		AddHeaderOption("$SPE_Auto Perk")
		autoPerkOID_M = AddMenuOption("$SPE_Auto Perk", autoPerkList[autoPerkIndex], AutoPerkFlag)
		AddEmptyOption()
		AutoAlchemyOID_B = AddToggleOption("$SPE_Alchemy", AutoAlchemyState, AutoAlchemyFlag)
		AutoAlterationOID_B = AddToggleOption("$SPE_Alteration", AutoAlterationState, AutoAlterationFlag)
		AutoArcheryOID_B = AddToggleOption("$SPE_Archery", AutoArcheryState, AutoArcheryFlag)
		AutoBlockOID_B = AddToggleOption("$SPE_Block", AutoBlockState, AutoBlockFlag)
		AutoConjurationOID_B = AddToggleOption("$SPE_Conjuration", AutoConjurationState, AutoConjurationFlag)
		AutoDestructionOID_B = AddToggleOption("$SPE_Destruction", AutoDestructionState, AutoDestructionFlag)
		AutoEnchantingOID_B = AddToggleOption("$SPE_Enchanting", AutoEnchantingState, AutoEnchantingFlag)
		AutoHeavyArmorOID_B = AddToggleOption("$SPE_HeavyArmor", AutoHeavyArmorState, AutoHeavyArmorFlag)
		AutoIllusionOID_B = AddToggleOption("$SPE_Illusion", AutoIllusionState, AutoIllusionFlag)
		AutoLightArmorOID_B = AddToggleOption("$SPE_LightArmor", AutoLightArmorState, AutoLightArmorFlag)
		AutoLockpickingOID_B = AddToggleOption("$SPE_Lockpicking", AutoLockpickingState, AutoLockpickingFlag)
		AutoOneHandedOID_B = AddToggleOption("$SPE_OneHanded", AutoOneHandedState, AutoOneHandedFlag)
		AutoPickpocketOID_B = AddToggleOption("$SPE_Pickpocket", AutoPickpocketState, AutoPickpocketFlag)
		AutoRestorationOID_B = AddToggleOption("$SPE_Restoration", AutoRestorationState, AutoRestorationFlag)
		AutoSmithingOID_B = AddToggleOption("$SPE_Smithing", AutoSmithingState, AutoSmithingFlag)
		AutoSneakOID_B = AddToggleOption("$SPE_Sneak", AutoSneakState, AutoSneakFlag)
		AutoSpeechOID_B = AddToggleOption("$SPE_Speech", AutoSpeechState, AutoSpeechFlag)
		AutoTwoHandedOID_B = AddToggleOption("$SPE_TwoHanded", AutoTwoHandedState, AutoTwoHandedFlag)

		SetCursorPosition(1)
		AddHeaderOption("$SPE_Disable Individual Trees")
		disableTreesEnableOID_B = AddToggleOption("$SPE_Allow Disabling", disableTreesEnabled)
		AddEmptyOption()
		DisableAlchemyOID_B = AddToggleOption("$SPE_Alchemy", DisableAlchemyState, disableTreesFlag)
		DisableAlterationOID_B = AddToggleOption("$SPE_Alteration", DisableAlterationState, disableTreesFlag)
		DisableArcheryOID_B = AddToggleOption("$SPE_Archery", DisableArcheryState, disableTreesFlag)
		DisableBlockOID_B = AddToggleOption("$SPE_Block", DisableBlockState, disableTreesFlag)
		DisableConjurationOID_B = AddToggleOption("$SPE_Conjuration", DisableConjurationState, disableTreesFlag)
		DisableDestructionOID_B = AddToggleOption("$SPE_Destruction", DisableDestructionState, disableTreesFlag)
		DisableEnchantingOID_B = AddToggleOption("$SPE_Enchanting", DisableEnchantingState, disableTreesFlag)
		DisableHeavyArmorOID_B = AddToggleOption("$SPE_HeavyArmor", DisableHeavyArmorState, disableTreesFlag)
		DisableIllusionOID_B = AddToggleOption("$SPE_Illusion", DisableIllusionState, disableTreesFlag)
		DisableLightArmorOID_B = AddToggleOption("$SPE_LightArmor", DisableLightArmorState, disableTreesFlag)
		DisableLockpickingOID_B = AddToggleOption("$SPE_Lockpicking", DisableLockpickingState, disableTreesFlag)
		DisableOneHandedOID_B = AddToggleOption("$SPE_OneHanded", DisableOneHandedState, disableTreesFlag)
		DisablePickpocketOID_B = AddToggleOption("$SPE_Pickpocket", DisablePickpocketState, disableTreesFlag)
		DisableRestorationOID_B = AddToggleOption("$SPE_Restoration", DisableRestorationState, disableTreesFlag)
		DisableSmithingOID_B = AddToggleOption("$SPE_Smithing", DisableSmithingState, disableTreesFlag)
		DisableSneakOID_B = AddToggleOption("$SPE_Sneak", DisableSneakState, disableTreesFlag)
		DisableSpeechOID_B = AddToggleOption("$SPE_Speech", DisableSpeechState, disableTreesFlag)
		DisableTwoHandedOID_B = AddToggleOption("$SPE_TwoHanded", DisableTwoHandedState, disableTreesFlag)
	ElseIf (page == "$SPE_Advanced")
		AddHeaderOption("$SPE_Advanced Options")
		advancedEnableOID_B = AddToggleOption("$SPE_Enable", advancedEnabled)
		etherealReqOID_B = AddToggleOption("$SPE_Ethereal Arrows Required", etherealReqState, advancedFlag)
		weaponSpeedOID_M = AddMenuOption("$SPE_Weapon Speed", weaponSpeedMode[weaponSpeedIndex], advancedFlag)
		speedToleranceOID_S = AddSliderOption("$SPE_Weapon Speed Tolerance", tolerance, "{2}", advancedFlag)
		bfNameOID_B = AddToggleOption("$SPE_Use Custom Pet Name", bfNameState, advancedFlag)
		labelAlchemyOID_B = AddToggleOption("$SPE_Use Alchemy Label", labelAlchemyState, advancedFlag)
		labelEnchantingOID_B = AddToggleOption("$SPE_Use Enchanting Label", labelEnchantingState, advancedFlag)
		resetAliasesOID_B = AddToggleOption("$SPE_Reset Aliases", resetAliasesState, advancedFlag)
		
		SetCursorPosition(1)
		setPerksOID_S = AddSliderOption("$SPE_Set Perk Points", perkPoints, "{0}", advancedFlag)
		
		AddEmptyOption()
		hardcoreOID_B = AddToggleOption("$SPE_Hardcore Mode", hardcoreState, advancedFlag)
		
		AddEmptyOption()
		uninstallOID_B = AddToggleOption("$SPE_Uninstall SPERG", uninstallState, advancedFlag)
	EndIf
EndEvent

Function ToggleAdvancedFlags(bool on = true)
	If on
		advancedFlag = OPTION_FLAG_NONE
	Else
		advancedFlag = OPTION_FLAG_DISABLED
	EndIf
	SetOptionFlags(etherealReqOID_B, advancedFlag, true)
	SetOptionFlags(weaponSpeedOID_M, advancedFlag, true)
	SetOptionFlags(speedToleranceOID_S, advancedFlag, true)
	SetOptionFlags(labelAlchemyOID_B, advancedFlag, true)
	SetOptionFlags(labelEnchantingOID_B, advancedFlag, true)
	SetOptionFlags(setPerksOID_S, advancedFlag, true)
	SetOptionFlags(hardcoreOID_B, advancedFlag, true)
	SetOptionFlags(resetAliasesOID_B, advancedFlag, true)
	SetOptionFlags(bfNameOID_B, advancedFlag, true)
	SetOptionFlags(uninstallOID_B, advancedFlag)
EndFunction

Function InitializeMenu()
	If (LastPage == "$SPE_General")
		meltingState = SPEMelting.GetValue() as bool
		questRewardState = SPEQuestRewards.GetValue() as bool
		autoPerkIndex = AutoPerk.GetValue() as Int
		refundAutoState = RefundAutoPerks.GetValue() as Int
		resetPenaltyState = SPEPerkResetPenalty.GetValue() as bool
		perkResetState = SPEMenuPerkReset.GetValue() as bool
		staffFixState = PlayerRef.HasPerk(SPEBaseStaffManager) as bool
		shoutExpState = SPEShoutExp.GetValue() as bool
		ingredientExpState = SPEIngredientExp.GetValue() as bool
		potionExpState = SPEPotionExp.GetValue() as bool
		armorExpInterval = SPEArmorExp.GetValue() as Float
		foodExpIndex = SPEFoodExpMode.GetValue() as Int
	ElseIf (LastPage == "$SPE_Fixes & Compatibility")
		brawlModeState = SPEBrawlMode.GetValue() as bool
		unarmedIndex = SPEUnarmed.GetValue() as Int
		unarmedDamageState = SPEUnarmedDamage.GetValue() as bool
		critFixState = SPECriticalFix.GetValue() as bool
		fixNecromageState = SPEFixNecromage.GetValue() as bool
		fixImpactState = SPEFixImpact.GetValue() as bool
		boundSpellsState = PlayerRef.HasPerk(SPEBaseBoundSpells) as bool
		wardSpellsState = PlayerRef.HasPerk(SPEBaseWardSpells) as bool
		legendarySkillState = SPELegendarySkills.GetValue() as bool
		checkAutoState = SPECheckAuto.GetValue() as bool
		DisableMagicScalingState = SPEDisableMagicScaling.GetValue() as bool
	ElseIf (LastPage == "$SPE_Perk Settings")
		sunderIndex = SPESunderMode.GetValue() as Int
		customAARaceIndex = SPECustomAARace.GetValue() as Int
		useCustomAAState = SPEUseCustomAARace.GetValue() as bool
		summonIndex = SPESummonMode.GetValue() as Int
		frostAuraIndex = SPEFrostAuraMode.GetValue() as Int
		illusionChargeIndex = SPEIllusionChargeMode.GetValue() as Int
		etherealAmmoIndex = SPEEtherealAmmoMode.GetValue() as Int
		THSneakState = SPE2hSneakAttack.GetValue() as bool
		bfTypeIndex = SPEBF_PetType.GetValue() as Int
		bfSellingState = SPEBF_SimpleSelling.GetValue() as bool
		bfTrackState = SPEBF_TrackPet.GetValue() as bool
		waxKeyState = SPEWaxKey.GetValue() as bool
		GLCostState = SPEGoodListenerCostMode.GetValue() as bool
		;set BF menu according to loaded DLCs
		bool DawnguardLoaded = SPEDawnguardLoaded.GetValue() as bool
		bool DragonbornLoaded = SPEDragonbornLoaded.GetValue() as bool
		If DawnguardLoaded && DragonbornLoaded  ;all relevant DLC
			bfTypeList = bfTypesAllDLC
		ElseIf DawnguardLoaded && DragonbornLoaded == 0 ;DG only
			bfTypeList = bfTypesDG
		ElseIf DawnguardLoaded == 0 && DragonbornLoaded ;DB only
			bfTypeList = bfTypesDB
		Else ;No DLC
			bfTypeList = bfTypesNoDLC
		EndIf
	ElseIf (LastPage == "$SPE_Skill Settings")
		autoPerkIndex = AutoPerk.GetValue() as Int
		AutoAlchemyState = AutoPerkAlchemy.GetValue() as bool
		AutoAlterationState = AutoPerkAlteration.GetValue() as bool
		AutoArcheryState = AutoPerkArchery.GetValue() as bool
		AutoBlockState = AutoPerkBlock.GetValue() as bool
		AutoConjurationState = AutoPerkConjuration.GetValue() as bool
		AutoDestructionState = AutoPerkDestruction.GetValue() as bool
		AutoEnchantingState = AutoPerkEnchanting.GetValue() as bool
		AutoHeavyArmorState = AutoPerkHeavyArmor.GetValue() as bool
		AutoIllusionState = AutoPerkIllusion.GetValue() as bool
		AutoLightArmorState = AutoPerkLightArmor.GetValue() as bool
		AutoLockpickingState = AutoPerkLockpicking.GetValue() as bool
		AutoOneHandedState = AutoPerkOneHanded.GetValue() as bool
		AutoPickpocketState = AutoPerkPickpocket.GetValue() as bool
		AutoRestorationState = AutoPerkRestoration.GetValue() as bool
		AutoSmithingState = AutoPerkSmithing.GetValue() as bool
		AutoSneakState = AutoPerkSneak.GetValue() as bool
		AutoSpeechState = AutoPerkSpeech.GetValue() as bool
		AutoTwoHandedState = AutoPerkTwoHanded.GetValue() as bool
		DisableAlchemyState = SPEDisableAlchemy.GetValue() as bool
		DisableAlterationState = SPEDisableAlteration.GetValue() as bool
		DisableArcheryState = SPEDisableArchery.GetValue() as bool
		DisableBlockState = SPEDisableBlock.GetValue() as bool
		DisableConjurationState = SPEDisableConjuration.GetValue() as bool
		DisableDestructionState = SPEDisableDestruction.GetValue() as bool
		DisableEnchantingState = SPEDisableEnchanting.GetValue() as bool
		DisableHeavyArmorState = SPEDisableHeavyArmor.GetValue() as bool
		DisableIllusionState = SPEDisableIllusion.GetValue() as bool
		DisableLightArmorState = SPEDisableLightArmor.GetValue() as bool
		DisableLockpickingState = SPEDisableLockpicking.GetValue() as bool
		DisableOneHandedState = SPEDisableOneHanded.GetValue() as bool
		DisablePickpocketState = SPEDisablePickpocket.GetValue() as bool
		DisableRestorationState = SPEDisableRestoration.GetValue() as bool
		DisableSmithingState = SPEDisableSmithing.GetValue() as bool
		DisableSneakState = SPEDisableSneak.GetValue() as bool
		DisableSpeechState = SPEDisableSpeech.GetValue() as bool
		DisableTwoHandedState = SPEDisableTwoHanded.GetValue() as bool
	ElseIf (LastPage == "$SPE_Advanced")
		etherealReqState = SPEEtherealArrowsRequired.GetValue() as bool
		uninstallState = SPEUninstall.GetValue() as bool
		weaponSpeedIndex = SPEWeaponSpeed.GetValue() as Int
		tolerance = SPEWeaponSpeedTolerance.GetValue() as Float
		labelAlchemyState = SPELabelAlchemyDefault.GetValue() as bool
		labelEnchantingState = SPELabelEnchantingDefault.GetValue() as bool
		perkPoints = Game.GetPerkPoints() as Float
		hardcoreState = SPEHardcoreMode.GetValue() as bool
		resetAliasesState = SPEResetAliases.GetValue() as bool
		bfNameState = SPEBF_UseCustomName.GetValue() as bool
	EndIf
EndFunction

Function ProcessOption(int option, string mode, int index = 0, float value = 0.0)

	;GENERAL SETTINGS PAGE
	If (LastPage == "$SPE_General")

		If option == meltingOID_B
			If mode == "Select"
				meltingState = ToggleOption(meltingOID_B, meltingState, SPEMelting)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Salvage")
			ElseIf mode == "Default"
				meltingState = ToggleOption(meltingOID_B, meltingState, SPEMelting, 1)
			EndIf
			
		ElseIf option == questRewardOID_B
			If mode == "Select"
				questRewardState = ToggleOption(questRewardOID_B, questRewardState, SPEQuestRewards)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_QuestRewards")
			ElseIf mode == "Default"
				questRewardState = ToggleOption(questRewardOID_B, questRewardState, SPEQuestRewards, 1)
			EndIf
			
		ElseIf option == shoutExpOID_B
			If mode == "Select"
				shoutExpState = ToggleOption(shoutExpOID_B, shoutExpState, SPEShoutExp)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Shout Exp")
			ElseIf mode == "Default"
				shoutExpState = ToggleOption(shoutExpOID_B, shoutExpState, SPEShoutExp, 1)
			EndIf
			
		ElseIf option == ingredientExpOID_B
			If mode == "Select"
				ingredientExpState = ToggleOption(ingredientExpOID_B, ingredientExpState, SPEIngredientExp)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Ingredient Exp")
			ElseIf mode == "Default"
				ingredientExpState = ToggleOption(ingredientExpOID_B, ingredientExpState, SPEIngredientExp, 1)
			EndIf
			
		ElseIf option == potionExpOID_B
			If mode == "Select"
				potionExpState = ToggleOption(potionExpOID_B, potionExpState, SPEPotionExp)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Potion Exp")
			ElseIf mode == "Default"
				potionExpState = ToggleOption(potionExpOID_B, potionExpState, SPEPotionExp, 1)
			EndIf
			
		ElseIf option == staffFixOID_B
			If mode == "Select"
				staffFixState = TogglePerkOption(staffFixOID_B, staffFixState, SPEBaseStaffManager)	
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Staff Leveling")
			ElseIf mode == "Default"
				staffFixState = TogglePerkOption(staffFixOID_B, staffFixState, SPEBaseStaffManager, 1)
			EndIf

		ElseIf option == armorExpOID_S
			If mode == "SliderOpen"
				SetSliderDialogStartValue(armorExpInterval)
				SetSliderDialogDefaultValue(6.00)
				SetSliderDialogRange(0.00, 25.00)
				SetSliderDialogInterval(1.00)
			ElseIf mode == "SliderAccept"
				armorExpInterval = value
				SPEArmorExp.SetValue(armorExpInterval as Int)
				SetSliderOptionValue(armorExpOID_S, armorExpInterval, "{0}")
				(self as Quest).SendModEvent("SPE_ResetArmorExp")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Armor Exp")
			ElseIf mode == "Default"
				armorExpInterval = 6.00
				SPEArmorExp.SetValue(armorExpInterval as Int)
				SetSliderOptionValue(armorExpOID_S, armorExpInterval, "{0}")
				(self as Quest).SendModEvent("SPE_ResetArmorExp")
			EndIf

		ElseIf option == foodExpOID_M
			If mode == "MenuOpen"
				OpenMenu(foodExpList, foodExpIndex, 1)
			ElseIf mode == "MenuAccept"
				foodExpIndex = SetMenuOption(foodExpOID_M, foodExpList, foodExpIndex, SPEFoodExpMode, index)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Food Exp")
			ElseIf mode == "Default"
				foodExpIndex = SetMenuOption(foodExpOID_M, foodExpList, foodExpIndex, SPEFoodExpMode, 1)
			EndIf
			
		ElseIf option == autoPerkGeneralOID_M
			If mode == "MenuOpen"
				OpenMenu(autoPerkList, autoPerkIndex, 1)
			ElseIf mode == "MenuAccept"
				autoPerkIndex = SetMenuOption(autoPerkGeneralOID_M, autoPerkList, autoPerkIndex, AutoPerk, index)
				If autoPerkIndex == 2
					ToggleTreeFlags(true, true, false)
				Else
					ToggleTreeFlags(false, true, false)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Auto Perk")
			ElseIf mode == "Default"
				autoPerkIndex = SetMenuOption(autoPerkGeneralOID_M, autoPerkList, autoPerkIndex, AutoPerk, 1)
				ToggleTreeFlags(false, true, false)
			EndIf
			
		ElseIf option == resetPenaltyOID_B
			If mode == "Select"
				resetPenaltyState = ToggleOption(resetPenaltyOID_B, resetPenaltyState, SPEPerkResetPenalty)
				SPEBeginningQuest.RegisterForSingleUpdate(0)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_ResetPenalty")
			ElseIf mode == "Default"
				resetPenaltyState = ToggleOption(resetPenaltyOID_B, resetPenaltyState, SPEPerkResetPenalty, 1)
			EndIf
			
		ElseIf option == perkResetOID_B
			If mode == "Select"
				perkResetState = ToggleOption(perkResetOID_B, perkResetState, SPEMenuPerkReset)
				SPEBeginningQuest.RegisterForSingleUpdate(0)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_PerkReset")
			ElseIf mode == "Default"
				perkResetState = ToggleOption(perkResetOID_B, perkResetState, SPEMenuPerkReset, 0)
			EndIf
			
		ElseIf option == refundAutoOID_B
			If mode == "Select"
				refundAutoState = ToggleOption(refundAutoOID_B, refundAutoState, RefundAutoPerks)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Refund Auto")
			ElseIf mode == "Default"
				refundAutoState = ToggleOption(refundAutoOID_B, refundAutoState, RefundAutoPerks, 0)
			EndIf
		EndIf
			
	;FIXES AND COMPATIBILITY PAGE
	ElseIf (LastPage == "$SPE_Fixes & Compatibility")

		If option == brawlModeOID_B
			If mode == "Select"
				brawlModeState = ToggleOption(brawlModeOID_B, brawlModeState, SPEBrawlMode)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_BrawlMode")
			ElseIf mode == "Default"
				brawlModeState = ToggleOption(brawlModeOID_B, brawlModeState, SPEBrawlMode, 0)
			EndIf
			
		ElseIf option == legendarySkillOID_B
			If mode == "Select"
				legendarySkillState = ToggleOption(legendarySkillOID_B, legendarySkillState, SPELegendarySkills)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_LegendarySkill")
			ElseIf mode == "Default"
				legendarySkillState = ToggleOption(legendarySkillOID_B, legendarySkillState, SPELegendarySkills, 1)
			EndIf
			
		ElseIf option == unarmedDamageOID_B
			If mode == "Select"
				unarmedDamageState = ToggleOption(unarmedDamageOID_B, unarmedDamageState, SPEUnarmedDamage)
				(self as Quest).SendModEvent("SPE_UpdateUnarmed", strArg = "BuffsOnly")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_UnarmedDamage")
			ElseIf mode == "Default"
				unarmedDamageState = ToggleOption(unarmedDamageOID_B, unarmedDamageState, SPEUnarmedDamage, 1)
				(self as Quest).SendModEvent("SPE_UpdateUnarmed", strArg = "BuffsOnly")
			EndIf
			
		ElseIf option == fixNecromageOID_B
			If mode == "Select"
				fixNecromageState = ToggleOption(fixNecromageOID_B, fixNecromageState, SPEFixNecromage)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Fix Necromage")
			ElseIf mode == "Default"
				fixNecromageState = ToggleOption(fixNecromageOID_B, fixNecromageState, SPEFixNecromage, 0)
			EndIf
			
		ElseIf option == fixImpactOID_B
			If mode == "Select"
				fixImpactState = ToggleOption(fixImpactOID_B, fixImpactState, SPEFixImpact)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Fix Impact")
			ElseIf mode == "Default"
				fixImpactState = ToggleOption(fixImpactOID_B, fixImpactState, SPEFixImpact, 1)
			EndIf
			
		ElseIf option == critFixOID_B
			If mode == "Select"
				critFixState = ToggleOption(critFixOID_B, critFixState, SPECriticalFix)		
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Crit Fix")
			ElseIf mode == "Default"
				critFixState = ToggleOption(critFixOID_B, critFixState, SPECriticalFix, 1)
			EndIf
			
		ElseIf option == unarmedOID_M
			If mode == "MenuOpen"
				OpenMenu(unarmedList, unarmedIndex, 1)
			ElseIf mode == "MenuAccept"
				unarmedIndex = SetMenuOption(unarmedOID_M, unarmedList, unarmedIndex, SPEUnarmed, index)
				(self as Quest).SendModEvent("SPE_UpdateUnarmed", strArg = "FullReset")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Unarmed")
			ElseIf mode == "Default"
				unarmedIndex = SetMenuOption(unarmedOID_M, unarmedList, unarmedIndex, SPEUnarmed, 1)
				(self as Quest).SendModEvent("SPE_UpdateUnarmed", strArg = "FullReset")
			EndIf
			
		ElseIf option == boundSpellsOID_B
			If mode == "Select"
				boundSpellsState = TogglePerkOption(boundSpellsOID_B, boundSpellsState, SPEBaseBoundSpells)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Bound Spells")
			ElseIf mode == "Default"
				boundSpellsState = TogglePerkOption(boundSpellsOID_B, boundSpellsState, SPEBaseBoundSpells, 1)
			EndIf
		
		ElseIf option == wardSpellsOID_B
			If mode == "Select"
				wardSpellsState = TogglePerkOption(wardSpellsOID_B, wardSpellsState, SPEBaseWardSpells)
				SPEWardSpells.SetValue(wardSpellsState as int)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Ward Spells")
			ElseIf mode == "Default"
				wardSpellsState = TogglePerkOption(wardSpellsOID_B, wardSpellsState, SPEBaseWardSpells, 1)
				SPEWardSpells.SetValue(1)
			EndIf
		
		ElseIf option == DisableMagicScalingOID_B
			If mode == "Select"
				DisableMagicScalingState = ToggleOption(DisableMagicScalingOID_B, DisableMagicScalingState, SPEDisableMagicScaling)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Disable Magic Scaling")
			ElseIf mode == "Default"
				DisableMagicScalingState = ToggleOption(DisableMagicScalingOID_B, DisableMagicScalingState, SPEDisableMagicScaling, 0)
			EndIf
			
		ElseIf option == checkAutoOID_B
			If mode == "Select"
				checkAutoState = ToggleOption(checkAutoOID_B, checkAutoState, SPECheckAuto)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Check Auto")
			ElseIf mode == "Default"
				checkAutoState = ToggleOption(checkAutoOID_B, checkAutoState, SPECheckAuto, 0)
			EndIf
			
		EndIf

	;PERK SETTINGS PAGE
	ElseIf (LastPage == "$SPE_Perk Settings")

		If option == THSneakOID_B
			If mode == "Select"
				THSneakState = ToggleOption(THSneakOID_B, THSneakState, SPE2hSneakAttack)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Two Handed Sneak")
			ElseIf mode == "Default"
				THSneakState = ToggleOption(THSneakOID_B, THSneakState, SPE2hSneakAttack, 1)
			EndIf
			
		ElseIf option == useCustomAAOID_B
			If mode == "Select"
				useCustomAAState = ToggleOption(useCustomAAOID_B, useCustomAAState, SPEUseCustomAARace)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Use Custom AA Race")
			ElseIf mode == "Default"
				useCustomAAState = ToggleOption(useCustomAAOID_B, useCustomAAState, SPEUseCustomAARace, 0)
			EndIf
			
		ElseIf option == sunderOID_M
			If mode == "MenuOpen"
				OpenMenu(sunderList, sunderIndex, 2)
			ElseIf mode == "MenuAccept"
				sunderIndex = SetMenuOption(sunderOID_M, sunderList, sunderIndex, SPESunderMode, index)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Sunder")
			ElseIf mode == "Default"
				sunderIndex = SetMenuOption(sunderOID_M, sunderList, sunderIndex, SPESunderMode, 2)
			EndIf
			
		ElseIf option == customAARaceOID_M
			If mode == "MenuOpen"
				OpenMenu(customAARaceList, customAARaceIndex, 6)
			ElseIf mode == "MenuAccept"
				customAARaceIndex = SetMenuOption(customAARaceOID_M, customAARaceList, customAARaceIndex, SPECustomAARace, index)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_AARace")
			ElseIf mode == "Default"
				customAARaceIndex = SetMenuOption(customAARaceOID_M, customAARaceList, customAARaceIndex, SPECustomAARace, 6)
			EndIf
			
		ElseIf option == summonModeOID_M
			If mode == "MenuOpen"
				OpenMenu(summonList, summonIndex, 1)
			ElseIf mode == "MenuAccept"
				summonIndex = SetMenuOption(summonModeOID_M, summonList, summonIndex, SPESummonMode, index)
				If summonIndex == 3
					SPESummonQuest.RegisterForKey(summonKey)
				Else
					SPESummonQuest.UnregisterForAllKeys()
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Summon Mode")
			ElseIf mode == "Default"
				summonIndex = SetMenuOption(summonModeOID_M, summonList, summonIndex, SPESummonMode, 1)
				SPESummonQuest.UnregisterForAllKeys()
			EndIf
			
		ElseIf option == frostAuraOID_M
			If mode == "MenuOpen"
				OpenMenu(frostAuraList, frostAuraIndex, 1)
			ElseIf mode == "MenuAccept"
				frostAuraIndex = SetMenuOption(frostAuraOID_M, frostAuraList, frostAuraIndex, SPEFrostAuraMode, index)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Frost Aura")
			ElseIf mode == "Default"
				frostAuraIndex = SetMenuOption(frostAuraOID_M, frostAuraList, frostAuraIndex, SPEFrostAuraMode, 1)
			EndIf
			
		ElseIf option == illusionChargeOID_M
			If mode == "MenuOpen"
				OpenMenu(illusionChargeList, illusionChargeIndex, 1)
			ElseIf mode == "MenuAccept"
				illusionChargeIndex = SetMenuOption(illusionChargeOID_M, illusionChargeList, illusionChargeIndex, SPEIllusionChargeMode, index)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Illusion Charge")
			ElseIf mode == "Default"
				illusionChargeIndex = SetMenuOption(illusionChargeOID_M, illusionChargeList, illusionChargeIndex, SPEIllusionChargeMode, 1)
			EndIf
			
		ElseIf option == etherealAmmoOID_M
			If mode == "MenuOpen"
				OpenMenu(etherealAmmoList, etherealAmmoIndex, 1)
			ElseIf mode == "MenuAccept"
				etherealAmmoIndex = SetMenuOption(etherealAmmoOID_M, etherealAmmoList, etherealAmmoIndex, SPEEtherealAmmoMode, index)
				(self as Quest).SendModEvent("SPE_EtherealAmmoSwitch")
				If etherealAmmoIndex == 2
					(self as Quest).SendModEvent("SPE_EtherealAmmoRegister", numArg = ammoKey as float)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Ammo Mode")
			ElseIf mode == "Default"
				etherealAmmoIndex = SetMenuOption(etherealAmmoOID_M, etherealAmmoList, etherealAmmoIndex, SPEEtherealAmmoMode, 1)
				(self as Quest).SendModEvent("SPE_EtherealAmmoSwitch")
			EndIf
			
		ElseIf option == bfTypeOID_M
			If mode == "MenuOpen"
				OpenMenu(bfTypeList, bfTypeIndex, 2)
			ElseIf mode == "MenuAccept"
				If SPEDawnguardLoaded.GetValue() == 0 && SPEDragonbornLoaded.GetValue() == 1
					index += 2 ;adjust index for DB pets if DG isn't loaded
				EndIf
				bfTypeIndex = SetMenuOption(bfTypeOID_M, bfTypeList, bfTypeIndex, SPEBF_PetType, index)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Best Friend Type")
			ElseIf mode == "Default"
				bfTypeIndex = SetMenuOption(bfTypeOID_M, bfTypeList, bfTypeIndex, SPEBF_PetType, 2)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			EndIf
			
		ElseIf option == bfSellingOID_B
			If mode == "Select"
				bfSellingState = ToggleOption(bfSellingOID_B, bfSellingState, SPEBF_SimpleSelling)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Simple Selling")
			ElseIf mode == "Default"
				bfSellingState = ToggleOption(bfSellingOID_B, bfSellingState, SPEBF_SimpleSelling, 0)
			EndIf
			
		ElseIf option == bfTrackOID_B
			If mode == "Select"
				bfTrackState = ToggleOption(bfTrackOID_B, bfTrackState, SPEBF_TrackPet)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Track Pet")
			ElseIf mode == "Default"
				bfTrackState = ToggleOption(bfTrackOID_B, bfTrackState, SPEBF_TrackPet, 0)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			EndIf

		ElseIf option == GLCostOID_B
			If mode == "Select"
				GLCostState = ToggleOption(GLCostOID_B, GLCostState, SPEGoodListenerCostMode)
				(self as Quest).SendModEvent("SPE_UpdateGameSettings")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Good Listener")
			ElseIf mode == "Default"
				GLCostState = ToggleOption(GLCostOID_B, GLCostState, SPEGoodListenerCostMode, 0)
				(self as Quest).SendModEvent("SPE_UpdateGameSettings")
			EndIf

		ElseIf option == waxKeyOID_B
			If mode == "Select"
				waxKeyState = ToggleOption(waxKeyOID_B, waxKeyState, SPEWaxKey)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Use Wax Key")
			ElseIf mode == "Default"
				waxKeyState = ToggleOption(waxKeyOID_B, waxKeyState, SPEWaxKey, 0)
			EndIf

		ElseIf (option == summonKeyOID_K)
			If mode == "Highlight"
				SetInfoText("$SPE_SEL_Summon Key")
			ElseIf mode == "Default"
				summonKey = 78
				SetKeyMapOptionValue(summonKeyOID_K, summonKey)
				SPESummonQuest.UnregisterForAllKeys()
				If SPESummonMode.GetValue() == 3
					SPESummonQuest.RegisterForKey(summonKey)
				EndIf
			EndIf

		ElseIf (option == ammoKeyOID_K)
			If mode == "Highlight"
				SetInfoText("$SPE_SEL_Ammo Key")
			ElseIf mode == "Default"
				ammoKey = 74
				SetKeyMapOptionValue(ammoKeyOID_K, ammoKey)	
				(self as Quest).SendModEvent("SPE_EtherealAmmoClear")
				If SPEEtherealAmmoMode.GetValue() == 2
					(self as Quest).SendModEvent("SPE_EtherealAmmoRegister", numArg = ammoKey as float)
				EndIf
			EndIf
		EndIf


	;SKILL SETTINGS PAGE
	ElseIf (LastPage == "$SPE_Skill Settings")

		If option == autoPerkOID_M
			If mode == "MenuOpen"
				OpenMenu(autoPerkList, autoPerkIndex, 1)
			ElseIf mode == "MenuAccept"
				autoPerkIndex = SetMenuOption(autoPerkOID_M, autoPerkList, autoPerkIndex, AutoPerk, index)
				If autoPerkIndex == 2
					ToggleTreeFlags()
				Else
					ToggleTreeFlags(false)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Auto Perk")
			ElseIf mode == "Default"
				autoPerkIndex = SetMenuOption(autoPerkOID_M, autoPerkList, autoPerkIndex, AutoPerk, 1)
				ToggleTreeFlags(false)
			EndIf
			
		ElseIf (option == disableTreesEnableOID_B)
			If mode == "Select"
				disableTreesEnabled = !disableTreesEnabled
				If disableTreesEnabled == true
					autoPerkIndex = SetMenuOption(autoPerkOID_M, autoPerkList, autoPerkIndex, AutoPerk, 2)
					AutoPerkFlag = OPTION_FLAG_DISABLED
					disableTreesFlag = OPTION_FLAG_NONE
					ToggleTreeFlags(true, true, false)
				Else
					EnableAllTrees()
				EndIf
				ForcePageReset()
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Disable Trees")
			ElseIf mode == "Default"
				DisableTreesEnabled = false
				EnableAllTrees()
				ForcePageReset()
			EndIf

		Else ;it's a perk tree option. These take up a lot of space and aren't likely to change, so they're found below.
			ProcessPerkTree(option, mode)
		EndIf


	;ADVANCED PAGE
	ElseIf (LastPage == "$SPE_Advanced")
		If (option == advancedEnableOID_B)
			If mode == "Select"
				advancedEnabled = !advancedEnabled
				SetToggleOptionValue(advancedEnableOID_B, advancedEnabled)
				If advancedEnabled == true
					ToggleAdvancedFlags(true)
				Else
					ToggleAdvancedFlags(false)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_EnableAdvanced")
			ElseIf mode == "Default"
				advancedEnabled = false
				SetToggleOptionValue(advancedEnableOID_B, advancedEnabled)
				ToggleAdvancedFlags(false)
			EndIf

		ElseIf option == etherealReqOID_B
			If mode == "Select"
				etherealReqState = ToggleOption(etherealReqOID_B, etherealReqState, SPEEtherealArrowsRequired)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_EtherealRequired")
			ElseIf mode == "Default"
				etherealReqState = ToggleOption(etherealReqOID_B, etherealReqState, SPEEtherealArrowsRequired, 1)
			EndIf
			
		ElseIf option == weaponSpeedOID_M
			If mode == "MenuOpen"
				OpenMenu(weaponSpeedMode, weaponSpeedIndex, 1)
			ElseIf mode == "MenuAccept"
				weaponSpeedIndex = SetMenuOption(weaponSpeedOID_M, weaponSpeedMode, weaponSpeedIndex, SPEWeaponSpeed, index)
				(self as Quest).SendModEvent("SPE_UpdateHaste")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_WeaponSpeed")
			ElseIf mode == "Default"
				weaponSpeedIndex = SetMenuOption(weaponSpeedOID_M, weaponSpeedMode, weaponSpeedIndex, SPEWeaponSpeed, 1)
				(self as Quest).SendModEvent("SPE_UpdateHaste")
			EndIf
			
		ElseIf option == speedToleranceOID_S
			If mode == "SliderOpen"
				SetSliderDialogStartValue(tolerance)
				SetSliderDialogDefaultValue(1.0)
				SetSliderDialogRange(0.00,2.00)
				SetSliderDialogInterval(0.01)
			ElseIf mode == "SliderAccept"
				tolerance = value
				SPEWeaponSpeedTolerance.SetValue(tolerance)
				SetSliderOptionValue(speedToleranceOID_S, tolerance, "{2}")
				(self as Quest).SendModEvent("SPE_UpdateHaste")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_SpeedTolerance")
			ElseIf mode == "Default"
				tolerance = 1.0
				SPEWeaponSpeedTolerance.SetValue(tolerance)
				SetSliderOptionValue(speedToleranceOID_S, tolerance, "{2}")
				(self as Quest).SendModEvent("SPE_UpdateHaste")
			EndIf
			
		ElseIf option == bfNameOID_B
			If mode == "Select"
				bfNameState = ToggleOption(bfNameOID_B, bfNameState, SPEBF_UseCustomName)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Custom Name")
			ElseIf mode == "Default"
				bfNameState = ToggleOption(bfNameOID_B, bfNameState, SPEBF_UseCustomName, 0)
				If SPEBestFriendQuest.IsRunning()
					SPEBestFriendQuest.RegisterForSingleUpdate(0)
				EndIf
			EndIf

		ElseIf option == labelAlchemyOID_B
			If mode == "Select"
				labelAlchemyState = ToggleOption(labelAlchemyOID_B, labelAlchemyState, SPELabelAlchemyDefault)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_LabelAlchemy")
			ElseIf mode == "Default"
				labelAlchemyState = ToggleOption(labelAlchemyOID_B, labelAlchemyState, SPELabelAlchemyDefault, 1)
			EndIf
			
		ElseIf option == labelEnchantingOID_B
			If mode == "Select"
				labelEnchantingState = ToggleOption(labelEnchantingOID_B, labelEnchantingState, SPELabelEnchantingDefault)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_LabelEnchanting")
			ElseIf mode == "Default"
				labelEnchantingState = ToggleOption(labelEnchantingOID_B, labelEnchantingState, SPELabelEnchantingDefault, 1)
			EndIf
			
		ElseIf option == setPerksOID_S
			If mode == "SliderOpen"
				SetSliderDialogStartValue(perkPoints)
				SetSliderDialogDefaultValue(perkPoints)
				setSliderDialogRange(0.00, 40.00)
				SetSliderDialogInterval(1.00)
			ElseIf mode == "SliderAccept"
				perkPoints = value
				Game.SetPerkPoints(perkPoints as Int)
				SetSliderOptionValue(setPerksOID_S, perkPoints, "{0}")
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Set Perks")
			ElseIf mode == "Default"
				;it defaults to the current value, so do nothing.
			EndIf
			
		ElseIf option == hardcoreOID_B
			If mode == "Select"
				hardcoreState = ToggleOption(hardcoreOID_B, hardcoreState, SPEHardcoreMode)
				If hardcoreState == true
					(self as Quest).SendModEvent("SPE_HardcoreModeOn")
				Else
					(self as Quest).SendModEvent("SPE_HardcoreModeOff")
				EndIf
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Hardcore")
			ElseIf mode == "Default"
				hardcoreState = ToggleOption(hardcoreOID_B, hardcoreState, SPEHardcoreMode, 0)
				(self as Quest).SendModEvent("SPE_HardcoreModeOff")
			EndIf

		ElseIf option == resetAliasesOID_B
			If mode == "Select"
				resetAliasesState = ToggleOption(resetAliasesOID_B, resetAliasesState, SPEResetAliases)
				SPEUpdateQuest.RegisterForSingleUpdate(0)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Reset Aliases")
			ElseIf mode == "Default"
				resetAliasesState = ToggleOption(resetAliasesOID_B, resetAliasesState, SPEResetAliases, 0)
				SPEUpdateQuest.RegisterForSingleUpdate(0)
			EndIf

		ElseIf option == uninstallOID_B
			If mode == "Select"
				uninstallState = ToggleOption(uninstallOID_B, uninstallState, SPEUninstall)
				SPEUpdateQuest.RegisterForSingleUpdate(0)
			ElseIf mode == "Highlight"
				SetInfoText("$SPE_SEL_Uninstall")
			ElseIf mode == "Default"
				uninstallState = ToggleOption(uninstallOID_B, uninstallState, SPEUninstall, 0)
			EndIf
		EndIf
	EndIf
EndFunction

Event OnOptionKeyMapChange(int option, int keyCode, string conflictControl, string conflictName)
	bool continue = true
	If (conflictControl != "")
		string msg = "That key is already bound to '" + conflictControl + "'"
		If (conflictName != "")
			msg += " from '" + conflictName + "'"
		EndIf
		msg += ".\n\nDo you want to continue anyway?"
		continue = ShowMessage(msg, true, "$SPE_Yes", "$SPE_No")
	EndIf
	If (option == summonKeyOID_K)
		If continue
			summonKey = keyCode
			SetKeyMapOptionValue(summonKeyOID_K, summonKey)
			SPESummonQuest.UnregisterForAllKeys()
			If SPESummonMode.GetValue() == 3
				SPESummonQuest.RegisterForKey(summonKey)
			EndIf
		EndIf
	ElseIf (option == ammoKeyOID_K)
		If continue
			ammoKey = keyCode
			SetKeyMapOptionValue(ammoKeyOID_K, ammoKey)
			(self as Quest).SendModEvent("SPE_EtherealAmmoClear")
			If SPEEtherealAmmoMode.GetValue() == 2
				(self as Quest).SendModEvent("SPE_EtherealAmmoRegister", numArg = ammoKey as float)
			EndIf
		EndIf
	EndIf
EndEvent

string Function GetCustomControl(int keyCode)
	if (keyCode == summonKey)
		return "Summon Phantom Creatures"
	ElseIf (keyCode == ammoKey)
		return "Create Ethereal Ammo"
	Else
		return ""
	EndIf
EndFunction

;/--------------------------------------------------------------------------
|																			|
|							STATIC FUNCTIONS								|
|																			|
 ---------------------------------------------------------------------------

Below this point are several events and functions that probably don't need to be changed.

/;

Event OnOptionSelect(int option)
	ProcessOption(option, "Select")
EndEvent

Event OnOptionMenuOpen(int option)
	ProcessOption(option, "MenuOpen")
EndEvent

Event OnOptionMenuAccept(int option, int index)
	ProcessOption(option, "MenuAccept", index)
EndEvent

Event OnOptionSliderOpen(int option)
	ProcessOption(option, "SliderOpen")
EndEvent

Event OnOptionSliderAccept(int option, float value)
	ProcessOption(option, "SliderAccept", value = value)
EndEvent

Event OnOptionDefault(int option)
	ProcessOption(option, "Default")
EndEvent

Event OnOptionHighlight(int option)
	ProcessOption(option, "Highlight")
EndEvent

bool Function ToggleOption(int optionVar, bool stateVar, GlobalVariable globalVar, int mode = 2)
	If mode == 2
		stateVar = !stateVar
	Else
		stateVar = mode
	EndIf
	globalVar.SetValue(stateVar as int)
	SetToggleOptionValue(optionVar, stateVar)
	return stateVar
EndFunction

bool Function TogglePerkOption(int optionVar, bool stateVar, Perk optionPerk, int mode = 2)
	If mode == 2
		stateVar = !stateVar
	Else
		stateVar = mode
	EndIf
	If stateVar == 0
		PlayerRef.RemovePerk(optionPerk)
	Else
		PlayerRef.AddPerk(optionPerk)
	EndIf
	SetToggleOptionValue(optionVar, stateVar)
	return stateVar
EndFunction

int Function SetMenuOption(int optionVar, string[] optionList, int optionIndex, GlobalVariable globalVar, int value)
	optionIndex = value
	globalVar.SetValue(optionIndex)
	SetMenuOptionValue(optionVar, optionList[optionIndex])
	return optionIndex
EndFunction

Function OpenMenu(string[] optionList, int optionIndex, int value)
	SetMenuDialogOptions(optionList)
	SetMenuDialogStartIndex(optionIndex)
	SetMenuDialogDefaultIndex(value)
EndFunction

Function Reinitialize()
	firstInit = true
	OnConfigInit()
EndFunction

Event OnVersionUpdate(int a_version)
	; a_version is the new version, CurrentVersion is the old version
	If (CurrentVersion < a_version)
		OnConfigInit()
	EndIf
EndEvent


;/--------------------------------------------------------------------------
|																			|
|								PERK TREES									|
|																			|
 ---------------------------------------------------------------------------

Below this point are variables and functions related to the many individual perk tree settings.

/;
;perk tree specific variables
GlobalVariable Property AutoPerkAlchemy Auto
int AutoAlchemyOID_B
bool AutoAlchemyState = true
int AutoAlchemyFlag
GlobalVariable Property SPEDisableAlchemy Auto
int DisableAlchemyOID_B
bool DisableAlchemyState = false

GlobalVariable Property AutoPerkAlteration Auto
int AutoAlterationOID_B
bool AutoAlterationState = true
int AutoAlterationFlag
GlobalVariable Property SPEDisableAlteration Auto
int DisableAlterationOID_B
bool DisableAlterationState = false

GlobalVariable Property AutoPerkArchery Auto
int AutoArcheryOID_B
bool AutoArcheryState = true
int AutoArcheryFlag
GlobalVariable Property SPEDisableArchery Auto
int DisableArcheryOID_B
bool DisableArcheryState = false

GlobalVariable Property AutoPerkBlock Auto
int AutoBlockOID_B
bool AutoBlockState = true
int AutoBlockFlag
GlobalVariable Property SPEDisableBlock Auto
int DisableBlockOID_B
bool DisableBlockState = false

GlobalVariable Property AutoPerkConjuration Auto
int AutoConjurationOID_B
bool AutoConjurationState = true
int AutoConjurationFlag
GlobalVariable Property SPEDisableConjuration Auto
int DisableConjurationOID_B
bool DisableConjurationState = false

GlobalVariable Property AutoPerkDestruction Auto
int AutoDestructionOID_B
bool AutoDestructionState = true
int AutoDestructionFlag
GlobalVariable Property SPEDisableDestruction Auto
int DisableDestructionOID_B
bool DisableDestructionState = false

GlobalVariable Property AutoPerkEnchanting Auto
int AutoEnchantingOID_B
bool AutoEnchantingState = true
int AutoEnchantingFlag
GlobalVariable Property SPEDisableEnchanting Auto
int DisableEnchantingOID_B
bool DisableEnchantingState = false

GlobalVariable Property AutoPerkHeavyArmor Auto
int AutoHeavyArmorOID_B
bool AutoHeavyArmorState = true
int AutoHeavyArmorFlag
GlobalVariable Property SPEDisableHeavyArmor Auto
int DisableHeavyArmorOID_B
bool DisableHeavyArmorState = false

GlobalVariable Property AutoPerkIllusion Auto
int AutoIllusionOID_B
bool AutoIllusionState = true
int AutoIllusionFlag
GlobalVariable Property SPEDisableIllusion Auto
int DisableIllusionOID_B
bool DisableIllusionState = false

GlobalVariable Property AutoPerkLightArmor Auto
int AutoLightArmorOID_B
bool AutoLightArmorState = true
int AutoLightArmorFlag
GlobalVariable Property SPEDisableLightArmor Auto
int DisableLightArmorOID_B
bool DisableLightArmorState = false

GlobalVariable Property AutoPerkLockpicking Auto
int AutoLockpickingOID_B
bool AutoLockpickingState = true
int AutoLockpickingFlag
GlobalVariable Property SPEDisableLockpicking Auto
int DisableLockpickingOID_B
bool DisableLockpickingState = false

GlobalVariable Property AutoPerkOneHanded Auto
int AutoOneHandedOID_B
bool AutoOneHandedState = true
int AutoOneHandedFlag
GlobalVariable Property SPEDisableOneHanded Auto
int DisableOneHandedOID_B
bool DisableOneHandedState = false

GlobalVariable Property AutoPerkPickpocket Auto
int AutoPickpocketOID_B
bool AutoPickpocketState = true
int AutoPickpocketFlag
GlobalVariable Property SPEDisablePickpocket Auto
int DisablePickpocketOID_B
bool DisablePickpocketState = false

GlobalVariable Property AutoPerkRestoration Auto
int AutoRestorationOID_B
bool AutoRestorationState = true
int AutoRestorationFlag
GlobalVariable Property SPEDisableRestoration Auto
int DisableRestorationOID_B
bool DisableRestorationState = false

GlobalVariable Property AutoPerkSmithing Auto
int AutoSmithingOID_B
bool AutoSmithingState = true
int AutoSmithingFlag
GlobalVariable Property SPEDisableSmithing Auto
int DisableSmithingOID_B
bool DisableSmithingState = false

GlobalVariable Property AutoPerkSneak Auto
int AutoSneakOID_B
bool AutoSneakState = true
int AutoSneakFlag
GlobalVariable Property SPEDisableSneak Auto
int DisableSneakOID_B
bool DisableSneakState = false

GlobalVariable Property AutoPerkSpeech Auto
int AutoSpeechOID_B
bool AutoSpeechState = true
int AutoSpeechFlag
GlobalVariable Property SPEDisableSpeech Auto
int DisableSpeechOID_B
bool DisableSpeechState = false

GlobalVariable Property AutoPerkTwoHanded Auto
int AutoTwoHandedOID_B
bool AutoTwoHandedState = true
int AutoTwoHandedFlag
int DisableTwoHandedOID_B
bool DisableTwoHandedState = false
GlobalVariable Property SPEDisableTwoHanded Auto

Function ProcessPerkTree(int option, string mode)
	;auto trees
	If (option == AutoAlchemyOID_B)
		If mode == "Select"
			AutoAlchemyState = ToggleOption(AutoAlchemyOID_B, AutoAlchemyState, AutoPerkAlchemy)
		ElseIf mode == "Default"
			AutoAlchemyState = ToggleOption(AutoAlchemyOID_B, AutoAlchemyState, AutoPerkAlchemy, 1)
		EndIf
	ElseIf (option == AutoAlterationOID_B)
		If mode == "Select"
			AutoAlterationState = ToggleOption(AutoAlterationOID_B, AutoAlterationState, AutoPerkAlteration)
		ElseIf mode == "Default"
			AutoAlterationState = ToggleOption(AutoAlterationOID_B, AutoAlterationState, AutoPerkAlteration, 1)
		EndIf
	ElseIf (option == AutoArcheryOID_B)
		If mode == "Select"
			AutoArcheryState = ToggleOption(AutoArcheryOID_B, AutoArcheryState, AutoPerkArchery)
		ElseIf mode == "Default"
			AutoArcheryState = ToggleOption(AutoArcheryOID_B, AutoArcheryState, AutoPerkArchery, 1)
		EndIf
	ElseIf (option == AutoBlockOID_B)
		If mode == "Select"
			AutoBlockState = ToggleOption(AutoBlockOID_B, AutoBlockState, AutoPerkBlock)
		ElseIf mode == "Default"
			AutoBlockState = ToggleOption(AutoBlockOID_B, AutoBlockState, AutoPerkBlock, 1)
		EndIf
	ElseIf (option == AutoConjurationOID_B)
		If mode == "Select"
			AutoConjurationState = ToggleOption(AutoConjurationOID_B, AutoConjurationState, AutoPerkConjuration)
		ElseIf mode == "Default"
			AutoConjurationState = ToggleOption(AutoConjurationOID_B, AutoConjurationState, AutoPerkConjuration, 1)
		EndIf
	ElseIf (option == AutoDestructionOID_B)
		If mode == "Select"
			AutoDestructionState = ToggleOption(AutoDestructionOID_B, AutoDestructionState, AutoPerkDestruction)
		ElseIf mode == "Default"
			AutoDestructionState = ToggleOption(AutoDestructionOID_B, AutoDestructionState, AutoPerkDestruction, 1)
		EndIf
	ElseIf (option == AutoEnchantingOID_B)
		If mode == "Select"
			AutoEnchantingState = ToggleOption(AutoEnchantingOID_B, AutoEnchantingState, AutoPerkEnchanting)
		ElseIf mode == "Default"
			AutoEnchantingState = ToggleOption(AutoEnchantingOID_B, AutoEnchantingState, AutoPerkEnchanting, 1)
		EndIf
	ElseIf (option == AutoHeavyArmorOID_B)
		If mode == "Select"
			AutoHeavyArmorState = ToggleOption(AutoHeavyArmorOID_B, AutoHeavyArmorState, AutoPerkHeavyArmor)
		ElseIf mode == "Default"
			AutoHeavyArmorState = ToggleOption(AutoHeavyArmorOID_B, AutoHeavyArmorState, AutoPerkHeavyArmor, 1)
		EndIf
	ElseIf (option == AutoIllusionOID_B)
		If mode == "Select"
			AutoIllusionState = ToggleOption(AutoIllusionOID_B, AutoIllusionState, AutoPerkIllusion)
		ElseIf mode == "Default"
			AutoIllusionState = ToggleOption(AutoIllusionOID_B, AutoIllusionState, AutoPerkIllusion, 1)
		EndIf
	ElseIf (option == AutoLightArmorOID_B)
		If mode == "Select"
			AutoLightArmorState = ToggleOption(AutoLightArmorOID_B, AutoLightArmorState, AutoPerkLightArmor)
		ElseIf mode == "Default"
			AutoLightArmorState = ToggleOption(AutoLightArmorOID_B, AutoLightArmorState, AutoPerkLightArmor, 1)
		EndIf
	ElseIf (option == AutoLockpickingOID_B)
		If mode == "Select"
			AutoLockpickingState = ToggleOption(AutoLockpickingOID_B, AutoLockpickingState, AutoPerkLockpicking)
		ElseIf mode == "Default"
			AutoLockpickingState = ToggleOption(AutoLockpickingOID_B, AutoLockpickingState, AutoPerkLockpicking, 1)
		EndIf
	ElseIf (option == AutoOneHandedOID_B)
		If mode == "Select"
			AutoOneHandedState = ToggleOption(AutoOneHandedOID_B, AutoOneHandedState, AutoPerkOneHanded)
		ElseIf mode == "Default"
			AutoOneHandedState = ToggleOption(AutoOneHandedOID_B, AutoOneHandedState, AutoPerkOneHanded, 1)
		EndIf
	ElseIf (option == AutoPickpocketOID_B)
		If mode == "Select"
			AutoPickpocketState = ToggleOption(AutoPickpocketOID_B, AutoPickpocketState, AutoPerkPickpocket)
		ElseIf mode == "Default"
			AutoPickpocketState = ToggleOption(AutoPickpocketOID_B, AutoPickpocketState, AutoPerkPickpocket, 1)
		EndIf
	ElseIf (option == AutoRestorationOID_B)
		If mode == "Select"
			AutoRestorationState = ToggleOption(AutoRestorationOID_B, AutoRestorationState, AutoPerkRestoration)
		ElseIf mode == "Default"
			AutoRestorationState = ToggleOption(AutoRestorationOID_B, AutoRestorationState, AutoPerkRestoration, 1)
		EndIf
	ElseIf (option == AutoSmithingOID_B)
		If mode == "Select"
			AutoSmithingState = ToggleOption(AutoSmithingOID_B, AutoSmithingState, AutoPerkSmithing)
		ElseIf mode == "Default"
			AutoSmithingState = ToggleOption(AutoSmithingOID_B, AutoSmithingState, AutoPerkSmithing, 1)
		EndIf
	ElseIf (option == AutoSneakOID_B)
		If mode == "Select"
			AutoSneakState = ToggleOption(AutoSneakOID_B, AutoSneakState, AutoPerkSneak)
		ElseIf mode == "Default"
			AutoSneakState = ToggleOption(AutoSneakOID_B, AutoSneakState, AutoPerkSneak, 1)
		EndIf
	ElseIf (option == AutoSpeechOID_B)
		If mode == "Select"
			AutoSpeechState = ToggleOption(AutoSpeechOID_B, AutoSpeechState, AutoPerkSpeech)
		ElseIf mode == "Default"
			AutoSpeechState = ToggleOption(AutoSpeechOID_B, AutoSpeechState, AutoPerkSpeech, 1)
		EndIf
	ElseIf (option == AutoTwoHandedOID_B)
		If mode == "Select"
			AutoTwoHandedState = ToggleOption(AutoTwoHandedOID_B, AutoTwoHandedState, AutoPerkTwoHanded)
		ElseIf mode == "Default"
			AutoTwoHandedState = ToggleOption(AutoTwoHandedOID_B, AutoTwoHandedState, AutoPerkTwoHanded, 1)
		EndIf

	;disable trees
	ElseIf (option == DisableAlchemyOID_B)
		If mode == "Select"
			DisableAlchemyState = ToggleOption(DisableAlchemyOID_B, DisableAlchemyState, SPEDisableAlchemy)
			If DisableAlchemyState == true
				AutoAlchemyState = ToggleOption(AutoAlchemyOID_B, AutoAlchemyState, AutoPerkAlchemy)
				AutoAlchemyFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoAlchemyOID_B, AutoAlchemyFlag)
			Else
				AutoAlchemyFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoAlchemyOID_B, AutoAlchemyFlag)
			EndIf
		ElseIf mode == "Default"
			DisableAlchemyState = ToggleOption(DisableAlchemyOID_B, DisableAlchemyState, SPEDisableAlchemy, 0)
			AutoAlchemyFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoAlchemyOID_B, AutoAlchemyFlag)
		EndIf
	ElseIf (option == DisableAlterationOID_B)
		If mode == "Select"
			DisableAlterationState = ToggleOption(DisableAlterationOID_B, DisableAlterationState, SPEDisableAlteration)
			If DisableAlterationState == true
				AutoAlterationState = ToggleOption(AutoAlterationOID_B, AutoAlterationState, AutoPerkAlteration)
				AutoAlterationFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoAlterationOID_B, AutoAlterationFlag)
			Else
				AutoAlterationFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoAlterationOID_B, AutoAlterationFlag)
			EndIf
		ElseIf mode == "Default"
			DisableAlterationState = ToggleOption(DisableAlterationOID_B, DisableAlterationState, SPEDisableAlteration, 0)
			AutoAlterationFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoAlterationOID_B, AutoAlterationFlag)
		EndIf
	ElseIf (option == DisableArcheryOID_B)
		If mode == "Select"
			DisableArcheryState = ToggleOption(DisableArcheryOID_B, DisableArcheryState, SPEDisableArchery)
			If DisableArcheryState == true
				AutoArcheryState = ToggleOption(AutoArcheryOID_B, AutoArcheryState, AutoPerkArchery)
				AutoArcheryFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoArcheryOID_B, AutoArcheryFlag)
			Else
				AutoArcheryFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoArcheryOID_B, AutoArcheryFlag)
			EndIf
		ElseIf mode == "Default"
			DisableArcheryState = ToggleOption(DisableArcheryOID_B, DisableArcheryState, SPEDisableArchery, 0)
			AutoArcheryFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoArcheryOID_B, AutoArcheryFlag)
		EndIf
	ElseIf (option == DisableBlockOID_B)
		If mode == "Select"
			DisableBlockState = ToggleOption(DisableBlockOID_B, DisableBlockState, SPEDisableBlock)
			If DisableBlockState == true
				AutoBlockState = ToggleOption(AutoBlockOID_B, AutoBlockState, AutoPerkBlock)
				AutoBlockFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoBlockOID_B, AutoBlockFlag)
			Else
				AutoBlockFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoBlockOID_B, AutoBlockFlag)
			EndIf
		ElseIf mode == "Default"
			DisableBlockState = ToggleOption(DisableBlockOID_B, DisableBlockState, SPEDisableBlock, 0)
			AutoBlockFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoBlockOID_B, AutoBlockFlag)
		EndIf
	ElseIf (option == DisableConjurationOID_B)
		If mode == "Select"
			DisableConjurationState = ToggleOption(DisableConjurationOID_B, DisableConjurationState, SPEDisableConjuration)
			If DisableConjurationState == true
				AutoConjurationState = ToggleOption(AutoConjurationOID_B, AutoConjurationState, AutoPerkConjuration)
				AutoConjurationFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoConjurationOID_B, AutoConjurationFlag)
			Else
				AutoConjurationFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoConjurationOID_B, AutoConjurationFlag)
			EndIf
		ElseIf mode == "Default"
			DisableConjurationState = ToggleOption(DisableConjurationOID_B, DisableConjurationState, SPEDisableConjuration, 0)
			AutoConjurationFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoConjurationOID_B, AutoConjurationFlag)
		EndIf
	ElseIf (option == DisableDestructionOID_B)
		If mode == "Select"
			DisableDestructionState = ToggleOption(DisableDestructionOID_B, DisableDestructionState, SPEDisableDestruction)
			If DisableDestructionState == true
				AutoDestructionState = ToggleOption(AutoDestructionOID_B, AutoDestructionState, AutoPerkDestruction)
				AutoDestructionFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoDestructionOID_B, AutoDestructionFlag)
			Else
				AutoDestructionFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoDestructionOID_B, AutoDestructionFlag)
			EndIf
		ElseIf mode == "Default"
			DisableDestructionState = ToggleOption(DisableDestructionOID_B, DisableDestructionState, SPEDisableDestruction, 0)
			AutoDestructionFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoDestructionOID_B, AutoDestructionFlag)
		EndIf
	ElseIf (option == DisableEnchantingOID_B)
		If mode == "Select"
			DisableEnchantingState = ToggleOption(DisableEnchantingOID_B, DisableEnchantingState, SPEDisableEnchanting)
			If DisableEnchantingState == true
				AutoEnchantingState = ToggleOption(AutoEnchantingOID_B, AutoEnchantingState, AutoPerkEnchanting)
				AutoEnchantingFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoEnchantingOID_B, AutoEnchantingFlag)
			Else
				AutoEnchantingFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoEnchantingOID_B, AutoEnchantingFlag)
			EndIf
		ElseIf mode == "Default"
			DisableEnchantingState = ToggleOption(DisableEnchantingOID_B, DisableEnchantingState, SPEDisableEnchanting, 0)
			AutoEnchantingFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoEnchantingOID_B, AutoEnchantingFlag)
		EndIf
	ElseIf (option == DisableHeavyArmorOID_B)
		If mode == "Select"
			DisableHeavyArmorState = ToggleOption(DisableHeavyArmorOID_B, DisableHeavyArmorState, SPEDisableHeavyArmor)
			If DisableHeavyArmorState == true
				AutoHeavyArmorState = ToggleOption(AutoHeavyArmorOID_B, AutoHeavyArmorState, AutoPerkHeavyArmor)
				AutoHeavyArmorFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoHeavyArmorOID_B, AutoHeavyArmorFlag)
			Else
				AutoHeavyArmorFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoHeavyArmorOID_B, AutoHeavyArmorFlag)
			EndIf
		ElseIf mode == "Default"
			DisableHeavyArmorState = ToggleOption(DisableHeavyArmorOID_B, DisableHeavyArmorState, SPEDisableHeavyArmor, 0)
			AutoHeavyArmorFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoHeavyArmorOID_B, AutoHeavyArmorFlag)
		EndIf
	ElseIf (option == DisableIllusionOID_B)
		If mode == "Select"
			DisableIllusionState = ToggleOption(DisableIllusionOID_B, DisableIllusionState, SPEDisableIllusion)
			If DisableIllusionState == true
				AutoIllusionState = ToggleOption(AutoIllusionOID_B, AutoIllusionState, AutoPerkIllusion)
				AutoIllusionFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoIllusionOID_B, AutoIllusionFlag)
			Else
				AutoIllusionFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoIllusionOID_B, AutoIllusionFlag)
			EndIf
		ElseIf mode == "Default"
			DisableIllusionState = ToggleOption(DisableIllusionOID_B, DisableIllusionState, SPEDisableIllusion, 0)
			AutoIllusionFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoIllusionOID_B, AutoIllusionFlag)
		EndIf
	ElseIf (option == DisableLightArmorOID_B)
		If mode == "Select"
			DisableLightArmorState = ToggleOption(DisableLightArmorOID_B, DisableLightArmorState, SPEDisableLightArmor)
			If DisableLightArmorState == true
				AutoLightArmorState = ToggleOption(AutoLightArmorOID_B, AutoLightArmorState, AutoPerkLightArmor)
				AutoLightArmorFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoLightArmorOID_B, AutoLightArmorFlag)
			Else
				AutoLightArmorFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoLightArmorOID_B, AutoLightArmorFlag)
			EndIf
		ElseIf mode == "Default"
			DisableLightArmorState = ToggleOption(DisableLightArmorOID_B, DisableLightArmorState, SPEDisableLightArmor, 0)
			AutoLightArmorFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoLightArmorOID_B, AutoLightArmorFlag)
		EndIf
	ElseIf (option == DisableLockpickingOID_B)
		If mode == "Select"
			DisableLockpickingState = ToggleOption(DisableLockpickingOID_B, DisableLockpickingState, SPEDisableLockpicking)
			If DisableLockpickingState == true
				AutoLockpickingState = ToggleOption(AutoLockpickingOID_B, AutoLockpickingState, AutoPerkLockpicking)
				AutoLockpickingFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoLockpickingOID_B, AutoLockpickingFlag)
			Else
				AutoLockpickingFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoLockpickingOID_B, AutoLockpickingFlag)
			EndIf
		ElseIf mode == "Default"
			DisableLockpickingState = ToggleOption(DisableLockpickingOID_B, DisableLockpickingState, SPEDisableLockpicking, 0)
			AutoLockpickingFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoLockpickingOID_B, AutoLockpickingFlag)
		EndIf
	ElseIf (option == DisableOneHandedOID_B)
		If mode == "Select"
			DisableOneHandedState = ToggleOption(DisableOneHandedOID_B, DisableOneHandedState, SPEDisableOneHanded)
			If DisableOneHandedState == true
				AutoOneHandedState = ToggleOption(AutoOneHandedOID_B, AutoOneHandedState, AutoPerkOneHanded)
				AutoOneHandedFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoOneHandedOID_B, AutoOneHandedFlag)
			Else
				AutoOneHandedFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoOneHandedOID_B, AutoOneHandedFlag)
			EndIf
		ElseIf mode == "Default"
			DisableOneHandedState = ToggleOption(DisableOneHandedOID_B, DisableOneHandedState, SPEDisableOneHanded, 0)
			AutoOneHandedFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoOneHandedOID_B, AutoOneHandedFlag)
		EndIf
	ElseIf (option == DisablePickpocketOID_B)
		If mode == "Select"
			DisablePickpocketState = ToggleOption(DisablePickpocketOID_B, DisablePickpocketState, SPEDisablePickpocket)
			If DisablePickpocketState == true
				AutoPickpocketState = ToggleOption(AutoPickpocketOID_B, AutoPickpocketState, AutoPerkPickpocket)
				AutoPickpocketFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoPickpocketOID_B, AutoPickpocketFlag)
			Else
				AutoPickpocketFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoPickpocketOID_B, AutoPickpocketFlag)
			EndIf
		ElseIf mode == "Default"
			DisablePickpocketState = ToggleOption(DisablePickpocketOID_B, DisablePickpocketState, SPEDisablePickpocket, 0)
			AutoPickpocketFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoPickpocketOID_B, AutoPickpocketFlag)
		EndIf
	ElseIf (option == DisableRestorationOID_B)
		If mode == "Select"
			DisableRestorationState = ToggleOption(DisableRestorationOID_B, DisableRestorationState, SPEDisableRestoration)
			If DisableRestorationState == true
				AutoRestorationState = ToggleOption(AutoRestorationOID_B, AutoRestorationState, AutoPerkRestoration)
				AutoRestorationFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoRestorationOID_B, AutoRestorationFlag)
			Else
				AutoRestorationFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoRestorationOID_B, AutoRestorationFlag)
			EndIf
		ElseIf mode == "Default"
			DisableRestorationState = ToggleOption(DisableRestorationOID_B, DisableRestorationState, SPEDisableRestoration, 0)
			AutoRestorationFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoRestorationOID_B, AutoRestorationFlag)
		EndIf
	ElseIf (option == DisableSmithingOID_B)
		If mode == "Select"
			DisableSmithingState = ToggleOption(DisableSmithingOID_B, DisableSmithingState, SPEDisableSmithing)
			If DisableSmithingState == true
				AutoSmithingState = ToggleOption(AutoSmithingOID_B, AutoSmithingState, AutoPerkSmithing)
				AutoSmithingFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoSmithingOID_B, AutoSmithingFlag)
			Else
				AutoSmithingFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoSmithingOID_B, AutoSmithingFlag)
			EndIf
		ElseIf mode == "Default"
			DisableSmithingState = ToggleOption(DisableSmithingOID_B, DisableSmithingState, SPEDisableSmithing, 0)
			AutoSmithingFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoSmithingOID_B, AutoSmithingFlag)
		EndIf
	ElseIf (option == DisableSneakOID_B)
		If mode == "Select"
			DisableSneakState = ToggleOption(DisableSneakOID_B, DisableSneakState, SPEDisableSneak)
			If DisableSneakState == true
				AutoSneakState = ToggleOption(AutoSneakOID_B, AutoSneakState, AutoPerkSneak)
				AutoSneakFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoSneakOID_B, AutoSneakFlag)
			Else
				AutoSneakFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoSneakOID_B, AutoSneakFlag)
			EndIf
		ElseIf mode == "Default"
			DisableSneakState = ToggleOption(DisableSneakOID_B, DisableSneakState, SPEDisableSneak, 0)
			AutoSneakFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoSneakOID_B, AutoSneakFlag)
		EndIf
	ElseIf (option == DisableSpeechOID_B)
		If mode == "Select"
			DisableSpeechState = ToggleOption(DisableSpeechOID_B, DisableSpeechState, SPEDisableSpeech)
			If DisableSpeechState == true
				AutoSpeechState = ToggleOption(AutoSpeechOID_B, AutoSpeechState, AutoPerkSpeech)
				AutoSpeechFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoSpeechOID_B, AutoSpeechFlag)
			Else
				AutoSpeechFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoSpeechOID_B, AutoSpeechFlag)
			EndIf
		ElseIf mode == "Default"
			DisableSpeechState = ToggleOption(DisableSpeechOID_B, DisableSpeechState, SPEDisableSpeech, 0)
			AutoSpeechFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoSpeechOID_B, AutoSpeechFlag)
		EndIf
	ElseIf (option == DisableTwoHandedOID_B)
		If mode == "Select"
			DisableTwoHandedState = ToggleOption(DisableTwoHandedOID_B, DisableTwoHandedState, SPEDisableTwoHanded)
			If DisableTwoHandedState == true
				AutoTwoHandedState = ToggleOption(AutoTwoHandedOID_B, AutoTwoHandedState, AutoPerkTwoHanded)
				AutoTwoHandedFlag = OPTION_FLAG_DISABLED
				SetOptionFlags(AutoTwoHandedOID_B, AutoTwoHandedFlag)
			Else
				AutoTwoHandedFlag = OPTION_FLAG_NONE
				SetOptionFlags(AutoTwoHandedOID_B, AutoTwoHandedFlag)
			EndIf
		ElseIf mode == "Default"
			DisableTwoHandedState = ToggleOption(DisableTwoHandedOID_B, DisableTwoHandedState, SPEDisableTwoHanded, 0)
			AutoTwoHandedFlag = OPTION_FLAG_NONE
			SetOptionFlags(AutoTwoHandedOID_B, AutoTwoHandedFlag)
		EndIf
	EndIf
EndFunction

Function ToggleTreeFlags(bool on = true, bool ToggleAuto = true, bool update = true)
	int flagValue = OPTION_FLAG_DISABLED
	If on
		flagValue = OPTION_FLAG_NONE
	EndIf
	If ToggleAuto
		AutoAlchemyFlag = flagValue
		AutoAlterationFlag = flagValue
		AutoArcheryFlag = flagValue
		AutoBlockFlag = flagValue
		AutoConjurationFlag = flagValue
		AutoDestructionFlag = flagValue
		AutoEnchantingFlag = flagValue
		AutoHeavyArmorFlag = flagValue
		AutoIllusionFlag = flagValue
		AutoLightArmorFlag = flagValue
		AutoLockpickingFlag = flagValue
		AutoOneHandedFlag = flagValue
		AutoPickpocketFlag = flagValue
		AutoRestorationFlag = flagValue
		AutoSmithingFlag = flagValue
		AutoSneakFlag = flagValue
		AutoSpeechFlag = flagValue
		AutoTwoHandedFlag = flagValue
		If update
			SetOptionFlags(AutoAlchemyOID_B, AutoAlchemyFlag, true)
			SetOptionFlags(AutoAlterationOID_B, AutoAlterationFlag, true)
			SetOptionFlags(AutoArcheryOID_B, AutoArcheryFlag, true)
			SetOptionFlags(AutoBlockOID_B, AutoBlockFlag, true)
			SetOptionFlags(AutoConjurationOID_B, AutoConjurationFlag, true)
			SetOptionFlags(AutoDestructionOID_B, AutoDestructionFlag, true)
			SetOptionFlags(AutoEnchantingOID_B, AutoEnchantingFlag, true)
			SetOptionFlags(AutoHeavyArmorOID_B, AutoHeavyArmorFlag, true)
			SetOptionFlags(AutoIllusionOID_B, AutoIllusionFlag, true)
			SetOptionFlags(AutoLightArmorOID_B, AutoLightArmorFlag, true)
			SetOptionFlags(AutoLockpickingOID_B, AutoLockpickingFlag, true)
			SetOptionFlags(AutoOneHandedOID_B, AutoOneHandedFlag, true)
			SetOptionFlags(AutoPickpocketOID_B, AutoPickpocketFlag, true)
			SetOptionFlags(AutoRestorationOID_B, AutoRestorationFlag, true)
			SetOptionFlags(AutoSmithingOID_B, AutoSmithingFlag, true)
			SetOptionFlags(AutoSneakOID_B, AutoSneakFlag, true)
			SetOptionFlags(AutoSpeechOID_B, AutoSpeechFlag, true)
			SetOptionFlags(AutoTwoHandedOID_B, AutoTwoHandedFlag)
		EndIf
	Else ;tree disabling
		disableTreesFlag = flagValue
		If update
			SetOptionFlags(DisableAlchemyOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableAlterationOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableArcheryOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableBlockOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableConjurationOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableDestructionOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableEnchantingOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableHeavyArmorOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableIllusionOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableLightArmorOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableLockpickingOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableOneHandedOID_B, disableTreesFlag, true)
			SetOptionFlags(DisablePickpocketOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableRestorationOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableSmithingOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableSneakOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableSpeechOID_B, disableTreesFlag, true)
			SetOptionFlags(DisableTwoHandedOID_B, disableTreesFlag)
		EndIf
	EndIf
EndFunction

Function EnableAllTrees()
	SPEDisableAlchemy.SetValue(0)
	SPEDisableAlteration.SetValue(0)
	SPEDisableArchery.SetValue(0)
	SPEDisableBlock.SetValue(0)
	SPEDisableConjuration.SetValue(0)
	SPEDisableDestruction.SetValue(0)
	SPEDisableEnchanting.SetValue(0)
	SPEDisableHeavyArmor.SetValue(0)
	SPEDisableIllusion.SetValue(0)
	SPEDisableLightArmor.SetValue(0)
	SPEDisableLockpicking.SetValue(0)
	SPEDisableOneHanded.SetValue(0)
	SPEDisablePickpocket.SetValue(0)
	SPEDisableRestoration.SetValue(0)
	SPEDisableSmithing.SetValue(0)
	SPEDisableSneak.SetValue(0)
	SPEDisableSpeech.SetValue(0)
	SPEDisableTwoHanded.SetValue(0)
	disableTreesFlag = OPTION_FLAG_DISABLED
	ToggleTreeFlags(true, true, false)
	AutoPerkFlag = OPTION_FLAG_NONE
EndFunction

