Scriptname SPEDualCastManager extends SPEPlayerOnlyAbility  
{Workaround script for the lack of a simple way to detect if a spell was dual cast without editing the spell itself.}

GlobalVariable Property SPEIsDualCasting Auto
Keyword Property MagicShout Auto
bool spellWasDualCast = false
bool effectFinished = false

Function Initialize()
	RegisterForModEvent("SPE_DualCastStart", "OnDualCastStart")
	RegisterForModEvent("SPE_DualCastStop", "OnDualCastStop")
EndFunction

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnUpdate()
	If PlayerRef.GetEquippedSpell(0) != NONE && PlayerRef.GetEquippedSpell(0) == PlayerRef.GetEquippedSpell(1)
		GoToState("DualCasting")
	Else
		GoToState("")
	EndIf
EndEvent

Function StopMonitoring()
	SPEIsDualCasting.SetValue(0)
	GoToState("")
	spellWasDualCast = false
	effectFinished = true
EndFunction

Function OnDualCastStart(string eventName, string strArg, float numArg, Form sender)
	StopMonitoring()
EndFunction

Function OnDualCastStop(string eventName, string strArg, float numArg, Form sender)
	StopMonitoring()
EndFunction

State DualCasting

	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
		If akBaseObject as Spell
			StopMonitoring()
		EndIf
	EndEvent

	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
		If akBaseObject as Spell
			StopMonitoring()
		EndIf
	EndEvent
	
	Event OnSpellCast(Form akSpell)
		Spell spellCast = akSpell as Spell
		If spellCast && !spellCast.HasKeyword(MagicShout) ;make sure it's a spell, not shouts or alchemy	
			If SPEISDualCasting.GetValue() && effectFinished == false
				spellWasDualCast = true
				RegisterForSingleUpdate(2)
			EndIf
		EndIf
	EndEvent
	
	Event OnUpdate()
		If effectFinished
			SPEIsDualCasting.SetValue(0)
			spellWasDualCast = false
		EndIf
	EndEvent

	Function OnDualCastStart(string eventName, string strArg, float numArg, Form sender)
		SPEIsDualCasting.SetValue(1)
		UnregisterForUpdate()
		spellWasDualCast = false
		effectFinished = false
	EndFunction

	Function OnDualCastStop(string eventName, string strArg, float numArg, Form sender)
		If spellWasDualCast == false
			SPEIsDualCasting.SetValue(0)
		EndIf
		effectFinished = true
	EndFunction

EndState