Scriptname SPEExorcistScript extends ActiveMagicEffect
{Allows Turn Undead spells to instantly kill lower level undead.}

Spell Property SPEPerkExorcism Auto
Keyword Property MagicTurnUndead Auto
GlobalVariable Property SPEPerkExorcistKillLevel Auto
GlobalVariable Property SPEHardcoreMode Auto
FormList Property SPETurnUndeadSpells Auto
Actor Target

float Property LevelMultMin = 0.75 Auto
{Undead equal to or lower than this percent of the spell magnitude will always be killed.}

float Property LevelMultMax = 0.85 Auto
{Undead higher than this percent of the spell magnitude will never be instantly killed}

Event OnEffectStart(Actor akTarget, Actor akCaster)
	Target = akTarget
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	SPEPerkExorcistKillLevel.SetValue(0)
EndEvent

Event OnSpellCast(Form akSpell)
	If akSpell.HasKeyword(MagicTurnUndead) ;it's a turn undead spell, do something
		Spell SpellCast = akSpell as Spell
		float SpellMagnitude
		If SKSE.GetVersion() ;it's ok to use SKSE functions
			int index = SpellCast.GetNumEffects()
			While index > 0
				index -= 1
					If SpellCast.GetNthEffectMagicEffect(index).HasKeyword(MagicTurnUndead)
						SpellMagnitude = SpellCast.GetNthEffectMagnitude(index)
						index = 0
					EndIf
				EndWhile
		Else ;guess magnitude
			int index = SPETurnUndeadSpells.Find(SpellCast)
			If index == 0
				SpellMagnitude = 6
			ElseIf index == 1
				SpellMagnitude = 8
			ElseIf index == 2
				SpellMagnitude = 13
			ElseIf index == 3
				SpellMagnitude = 16
			ElseIf index == 4
				SpellMagnitude = 21
			Else ;can't find it, guess
				SpellMagnitude = 11
			EndIf
		EndIf
		float TotalMagnitude = SpellMagnitude * (Target.GetAV("Restoration") * 0.01 + 1) * (Target.GetAV("RestorationMod") * 0.01 + 1) * (Target.GetAV("RestorationPowerMod") * 0.01 + 1) * 1.25 ;extra 25% for necromage
		If SPEHardcoreMode.GetValue() == 1
			TotalMagnitude *= 0.80 ;lowers the effective level undead must be to survive
		EndIf
		SPEPerkExorcistKillLevel.SetValue((TotalMagnitude * Utility.RandomFloat(LevelMultMin, LevelMultMax)) as int)
		SPEPerkExorcism.Cast(Target)
	EndIf
EndEvent

