Scriptname SPEFeedbackScript extends SPEPlayerOnlyAbility
{Damages enemies in melee based on the equipped spells}

GlobalVariable Property SPEHardcoreMode Auto
Spell Property SPEPerkFeedbackShock Auto
Keyword Property MagicDamageShock Auto
Spell Property SPEPerkFeedbackFrost Auto
Keyword Property MagicDamageFrost Auto
Spell Property SPEPerkFeedbackFire Auto
Keyword Property MagicDamageFire Auto
int ProcChance = 100
Spell Proc

Function Initialize()
	RegisterForModEvent("SPE_HardcoreOn", "OnHardcoreEnable")
	RegisterForModEvent("SPE_HardcoreOff", "OnHardcoreDisable")
	RegisterForModEvent("SPE_OnMeleeHitEvent", "OnHitProc")
	If SPEHardcoreMode.GetValue() == 1
		ProcChance = 40
	EndIf
EndFunction

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		RegisterForSingleUpdate(0)
	EndIf	
EndEvent

Event OnUpdate()
	Proc = NONE
	Spell spellEquipped
	int index = 1
	While index >= 0
		spellEquipped = PlayerRef.GetEquippedSpell(index) ;check for spell
		If spellEquipped != NONE ;spell found
			If spellEquipped.HasKeyword(MagicDamageShock)
				Proc = SPEPerkFeedbackShock
				index = -1 ;quit searching
			ElseIf spellEquipped.HasKeyword(MagicDamageFrost)
				Proc = SPEPerkFeedbackFrost
				index = -1
			ElseIf spellEquipped.HasKeyword(MagicDamageFire)
				Proc = SPEPerkFeedbackFire
				index = -1
			EndIf
		EndIf
		index -= 1
	EndWhile
EndEvent

Function OnHardcoreEnable(string eventName, string strArg, float numArg, Form sender)
	ProcChance = 40
EndFunction

Function OnHardcoreDisable(string eventName, string strArg, float numArg, Form sender)
	ProcChance = 100
EndFunction

Function OnHitProc(string eventName, string strArg, float numArg, Form sender)
	If Proc != NONE && Utility.RandomInt(1,100) <= ProcChance
		PlayerRef.DoCombatSpellApply(Proc, sender as Actor)
	EndIf
EndFunction
