Scriptname SPEFurnitureScript Extends SPEPlayerOnlyAbility
{Creates and deletes an invisible crafting workstation to allow crafting at alchemy/enchanting benches}

Furniture Property FakeCraftingFurniture Auto
{The furniture to create.}
string Property Skill = "" Auto
{The skill used by the furniture.}
float Property ExpGain = 0.0 Auto
{Exp per item made if not using item value.}
ObjectReference InvisibleFurniture
bool Property UseValue = false Auto
{Use the value of the crafted item to determine exp. Default: false}
bool IsCrafting = false

Function Initialize()
	RegisterForModEvent("SPE_CreateFurniture", "CreateFurniture")
EndFunction

Function CreateFurniture(string eventName, string strArg, float numArg, Form sender)
	If strArg == Skill
		RegisterForAnimationEvent(PlayerRef, "IdleFurnitureExit")
		InvisibleFurniture = (sender as ObjectReference).PlaceAtMe(FakeCraftingFurniture)
		Utility.Wait(0.1)
		IsCrafting = true
		InvisibleFurniture.Activate(PlayerRef, true)
	EndIf
EndFunction

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If IsCrafting && akItemReference == NONE && akSourceContainer == NONE
		;if the player is crafting and an item just appeared in their inventory out of nowhere, it's safe to assume they made it.
		If UseValue == true
			If Skill == "Alchemy"
				ExpGain = ((akBaseItem.GetGoldValue() as float) * 0.75 * aiItemCount)
			ElseIf Skill == "Smithing" ;not currently used, but this formula should be correct
				ExpGain = ((25 + (3 * Math.Pow(akBaseItem.GetGoldValue() as float, 0.65))) * aiItemCount)
			ElseIf Skill == "Enchanting"
				ExpGain = 1 ;gold values are determined solely from the base item, so they're unreliable for enchanting.
			EndIf
		EndIf
		If Skill != "" && ExpGain > 0.0 ;we should be giving exp
			Game.AdvanceSkill(Skill, ExpGain)
		EndIf
	EndIf
EndEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	;player has exited furniture, clean up the invisible object
	IsCrafting = false
	Utility.Wait(0.2) ;deleting it too fast might get the player stuck in the exit animation, so delay just in case.
	InvisibleFurniture.Delete()
	UnregisterForAnimationEvent(PlayerRef, "IdleFurnitureExit")
EndEvent
