Scriptname SPEInstantRitual extends SPEPlayerOnlyAbility
{Interrupts a ritual cast to cast instantly once per hour.}

FormList Property SPERitualSpells Auto
Spell currentSpell

Function Initialize()
	RegisterForSingleUpdate(0)
EndFunction

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		GoToState("")
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject as Spell
		GoToState("")
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnUpdate()
	currentSpell = PlayerRef.GetEquippedSpell(1)
	If SPERitualSpells.HasForm(currentSpell)
		RegisterForAnimationEvent(PlayerRef, "weaponSheathe")
		RegisterForAnimationEvent(PlayerRef, "weaponDraw")
		If PlayerRef.IsWeaponDrawn() == 1
			GoToState("RitualReadied")
			RegisterForSingleUpdate(0.2)
		Else
			GoToState("RitualEquipped")
		EndIf
	Else
		UnregisterForAnimations()
	EndIf
EndEvent

Function UnregisterForAnimations()
	UnregisterForAnimationEvent(PlayerRef, "weaponSheathe")
	UnregisterForAnimationEvent(PlayerRef, "weaponDraw")
EndFunction

State RitualEquipped
	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
		If asEventName == "weaponDraw"
			GoToState("RitualReadied")
			RegisterForSingleUpdate(0.2)
		EndIf
	EndEvent
EndState

State RitualReadied
	Event OnUpdate()
		If PlayerRef.GetAnimationVariableBool("bRitualSpellActive") == 1 ;ritual being cast
			GoToState("CoolingDown")
			PlayerRef.InterruptCast()
			currentSpell.Cast(PlayerRef)
			UnregisterForAnimations()
			RegisterForSingleUpdateGameTime(1)
		Else
			RegisterForSingleUpdate(0.2)
		EndIf
	EndEvent
	
	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
		If asEventName == "weaponSheathe"
			UnregisterForUpdate()
			GoToState("RitualEquipped")
		EndIf
	EndEvent
EndState

State CoolingDown
	Event OnUpdateGameTime()
		GoToState("")
		RegisterForSingleUpdate(0)
	EndEvent
	
	;block everything until cooldown finishes
	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	EndEvent
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	EndEvent
	Event OnUpdate()
	EndEvent
EndState
