Scriptname SPELaunderChestScript extends ReferenceAlias  
{Handles the "cleaning" of stolen items and discount fine paying.}

ReferenceAlias Property DummyChest  Auto  
ReferenceAlias Property QuestTarget  Auto  
LocationAlias Property LocationName Auto
Faction Property CrimeFaction Auto
Message Property SPELaunderMessage Auto
Message Property SPELaunderMessageFine Auto
Message Property SPELaunderFail Auto
Message Property SPELaunderFailItem Auto
Message Property SPELaunderFailFine Auto
MiscObject Property Gold001 Auto
SPELaundererQuestScript Property SPELaunderQuest Auto
Book Property SPELaunderNote Auto
Book Property SPELaunderNote02 Auto
Book Property SPELaunderNoteNoTip Auto
int Bribed = 0
bool ArrowShowing
int totalItems
int expensiveItems

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If akBaseItem != Gold001
		totalItems += 1
		If akBaseItem.GetGoldValue() >= 2000
			expensiveitems += 1
		EndIf
	EndIf
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If akBaseItem != Gold001
		totalItems -= 1
		If akBaseItem.GetGoldValue() >= 2000
			expensiveitems -= 1
		EndIf
	EndIf
EndEvent

Event OnActivate(ObjectReference akActionRef)
	If SPELaunderQuest.doOnce == false ;add note if one hasn't been shown yet
		GetRef().AddItem(SPELaunderNote, 1)
		SPELaunderQuest.doOnce = true
	EndIf
	If ArrowShowing ;clear quest arrow if showing
		ArrowShowing = false
		QuestTarget.Clear()
		SPELaunderQuest.Chests -= 1
	EndIf
	If SPELaunderQuest.IsObjectiveDisplayed(10) && SPELaunderQuest.Chests == 0 ;clear quest objective
		SPELaunderQuest.SetObjectiveCompleted(10)
	EndIf
EndEvent

Event OnClose(ObjectReference akActionRef)
	If CrimeFaction.GetCrimeGold() || totalItems > 0 ;The chest can actually do something.
		If expensiveItems > 0 || CrimeFaction.GetCrimeGold() >= 2000 ;Expensive transaction requested
			If GetRef().GetItemCount(Gold001) >= 1000 ;Expensive transaction successful
				Bribed = 2
				RegisterForSingleUpdateGameTime(1)
				SPELaunderMessage.Show()
			Else ;Expensive transaction failed
				If SPELaunderQuest.PriceLetterGiven == false && GetRef().GetItemCount(Gold001) >= 200
					;one-time freebie with explanation letter
					Bribed = 3
					RegisterForSingleUpdateGameTime(1)
					SPELaunderMessage.Show()
				Else
					Bribed = 0
					If SPELaunderQuest.PriceLetterGiven == false ;forgot money, probably
						SPELaunderFail.Show()
					ElseIf expensiveItems ;Show items message if items exist
						SPELaunderFailItem.Show()
					Else ;Fines message otherwise
						SPELaunderFailFine.Show()
					EndIf
				EndIf
			EndIf
		Else ;Normal transaction requested
			If GetRef().GetItemCount(Gold001) >= 200 ;Normal transaction successful
				Bribed = 1
				RegisterForSingleUpdateGameTime(1)
				SPELaunderMessage.Show()
			Else ;Transaction failed
				Bribed = 0
				SPELaunderFail.Show() ;use generic message for cheap bribes
			EndIf
		EndIf
	EndIf
EndEvent
		

Event OnUpdateGameTime()
	If Bribed ;Make sure they haven't taken the money out
		
		;test for angry letters
		If SPELaunderQuest.TipLetterGiven == false
			If (Bribed == 1 && GetRef().GetItemCount(Gold001) == 200) || (Bribed == 2 && GetRef().GetItemCount(Gold001) == 1000)
				SPELaunderQuest.NoTip += 1
			Else
				SPELaunderQuest.NoTip = 0
			EndIf				
			If SPELaunderQuest.NoTip >= 10
				DummyChest.GetRef().AddItem(SPELaunderNoteNoTip, 1)
				SPELaunderQuest.TipLetterGiven = true
			EndIf
		EndIf
		If Bribed == 3 ;add explanation letter for expensive transactions
			GetRef().AddItem(SPELaunderNote02, 1)
			SPELaunderQuest.PriceLetterGiven = true
		EndIf
		
		;Perform 'transaction'
		GetRef().RemoveItem(Gold001, GetRef().GetItemCount(Gold001)) ;remove gold
		GetRef().RemoveAllItems(DummyChest.GetRef(), false, true) ;replicate stolen items
		DummyChest.GetRef().RemoveAllItems() ;remove stolen items from game
		CrimeFaction.SetCrimeGold(0) ;get rid of fines
		CrimeFaction.SetCrimeGoldViolent(0) ;both of them
		CrimeFaction.PlayerPayCrimeGold(false, false) ;causes weirdness, but better than the alternative
		Bribed = 0 ;ready for a new transaction
		If totalItems > 0 ;display arrow if items are present
			QuestTarget.ForceRefTo(GetRef())
			SPELaunderQuest.Chests += 1
			SPELaunderQuest.SetObjectiveDisplayed(10, true, true)
			ArrowShowing = true
		Else ;show fine cleared message if no items were present
			LocationName.ForceLocationTo(GetRef().GetCurrentLocation())
			SPELaunderMessageFine.Show()
		EndIf
	EndIf
EndEvent
