Scriptname SPEListUpdate extends Quest
{Adds the contents of one set of list to another set of lists so multiple mods can change the same list.}

float VersionNum = 0.0
GlobalVariable Property VersionNumber Auto
{A global variable of type float that tracks the current version of your mod.}
FormList Property SourceLists Auto
{A list of lists containing items to be added.}
FormList Property DestLists Auto
{A list of lists to add items to.}

Event OnInit()
	CheckForUpdate()
EndEvent

Function CheckForUpdate()
	If VersionNum < VersionNumber.GetValue()
		UpdateLists()
	EndIf
EndFunction

Function UpdateLists()
	VersionNum = VersionNumber.GetValue()
	int i = SourceLists.GetSize()
	If i != DestLists.GetSize()
		Debug.Trace("List update error: source and dest lists are not the same size. Aborting.")
		return
	EndIf
	FormList SourceList
	FormList DestList
	int n
	While i > 0
		i -= 1
		SourceList = SourceLists.GetAt(i) as FormList
		DestList = DestLists.GetAt(i) as FormList
		n = SourceList.GetSize()
		While n > 0
			n -= 1
			DestList.AddForm(SourceList.GetAt(n))
		EndWhile
	EndWhile
EndFunction