Scriptname SPEMagicArmorLeveling extends SPEPlayerOnlyAbility
{Compensates for less casting by giving skill xp when hit.}

int property AverageOneHandDamage = 11 Auto
int property AverageTwoHandDamage = 20 Auto
int property AverageBowDamage = 26 Auto

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	Actor Attacker = akAggressor as Actor
	If Attacker ;if it's not a trap or something
		If Attacker.IsHostileToActor(PlayerRef) && (akSource as Spell) == NONE ;no allies or spells
			int leftHand = Attacker.GetEquippedItemType(0)
			int mainHand = Attacker.GetEquippedItemType(1)
			float damageEstimate = 0
			If akProjectile != NONE
				If mainHand == 7 || mainHand == 12 ;bow or xbow attack
					damageEstimate = AverageBowDamage * (1 + Attacker.GetAV("Marksman") * 0.005)
				EndIf
			ElseIf abBashAttack ;minimal xp if bashed
				Game.AdvanceSkill("Alteration", 9)
			ElseIf leftHand == 0 && mainHand == 0 ;unarmed or creature attack
				damageEstimate = Attacker.GetAV("UnarmedDamage")
			ElseIf mainHand == 5 || mainHand == 6 ;two-hander
				damageEstimate = AverageTwoHandDamage * (1 + Attacker.GetAV("TwoHanded") * 0.005)
			ElseIf mainHand < 5 || leftHand < 5 ;one-hander
				damageEstimate = AverageOneHandDamage * (1 + Attacker.GetAV("OneHanded") * 0.005)
			EndIf
			If abPowerAttack
				damageEstimate *= 2
			EndIf
			float SkillXP = damageEstimate * (PlayerRef.GetAV("DamageResist") * 0.12 * 0.01) * 3
			If SkillXP > 0.0
				Game.AdvanceSkill("Alteration", SkillXP)
			EndIf
		EndIf
	EndIf
EndEvent
