Scriptname SPEMetallurgyScript extends SPEPlayerOnlyAbility
{Adds additional ore and ingots from the metallurgy perk.}

Keyword Property CraftingSmelter Auto
FormList Property SPEOreIngotList Auto
float[] OreIngotArray ;tracks how much ore/ingots to give player
float Property PercentIncrease = 0.5 Auto
{Percent more ore/ingots received. 0.5 = 50% increase.}
bool IsSmelting = false

Function Initialize()
	OreIngotArray = new float[22]
	AddInventoryEventFilter(SPEOreIngotList)
EndFunction

Event OnSit(ObjectReference akFurniture)
	If akFurniture.HasKeyword(CraftingSmelter)
		GoToState("Smelting")
	EndIf
EndEvent

Event OnGetUp(ObjectReference akFurniture)
	GoToState("")
EndEvent

State Smelting
	Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
		If akItemReference == NONE && akSourceContainer == NONE ;just to be safe
			int index = SPEOreIngotList.Find(akBaseItem)
			OreIngotArray[index] = OreIngotArray[index] + (aiItemCount as float * PercentIncrease)
			If OreIngotArray[index] >= 1
				int ExtraCount = OreIngotArray[index] as int
				OreIngotArray[index] = OreIngotArray[index] - ExtraCount
				GoToState("") ;don't count the extras
				PlayerRef.AddItem(akBaseItem, ExtraCount)
				GoToState("Smelting")
			EndIf
		EndIf
	EndEvent
EndState
