Scriptname SPEOnHitEvent extends SPEPlayerOnlyAbility
{Checks to see if it's safe to proc an effect on hit, then fires appropriate events.}

Keyword Property MagicInvisibility Auto
MagicEffect Property VoiceMakeEthereal Auto
GlobalVariable Property SPEBrawlMode Auto
SPEBrawlManager Property SPEBrawlQuest Auto
bool NoProc = false

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	Actor Attacker = akAggressor as Actor
	If Attacker != NONE ;don't activate for traps
		bool proc = true
		If SPEBrawlMode.GetValue() == 1 || SPEBrawlQuest.CheckForBrawl() == 1 ;check for off conditions
			proc = false
		ElseIf PlayerRef != NONE && Attacker.IsHostileToActor(PlayerRef) == 0 ;make sure it's not triggered by an ally
			proc = false
		ElseIf NoProc
			proc = false
		Else ;safe to proc
			float flags = (abHitBlocked as int) + (abPowerAttack as int * 2) + (abBashAttack as int * 4) + (abSneakAttack as int * 8)
			Attacker.SendModEvent("SPE_OnHitEvent", numArg = flags)
			If akProjectile == NONE && Attacker.GetEquippedItemType(1) != 7 ;Rule out spells and bows for melee only abilities.
				Attacker.SendModEvent("SPE_OnMeleeHitEvent", numArg = flags)
				If abHitBlocked == true
					Attacker.SendModEvent("SPE_OnBlockedHitEvent", numArg = flags)
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent

Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
	If akEffect == VoiceMakeEthereal || akEffect.HasKeyword(MagicInvisibility)
		NoProc = true
		RegisterForSingleUpdate(1)
	EndIf
EndEvent
