Scriptname SPEOnHitProc extends SPEPlayerOnlyAbility
{Script to attach magic effects on melee attackers with a percent chance.}

GlobalVariable Property SPEHardcoreMode Auto
int Property ProcChance = 100 Auto
{Percent chance to proc on hit. 0 = None, 100 = Always}
int Property ProcChanceHC = 100 Auto
{Percent chance to proc in hardcore mode.}
int Property Chance Auto Hidden
Spell Property ProcSpell Auto
{Spell to use for the proc.}
Spell Property ProcSpellHC Auto
{Spell to use for the proc in hardcore mode.}
Spell Property Proc Auto Hidden
bool Property SelfCast = true Auto
{Cast on self if true (default) or the attacker if false.}
int Property ProcMode = 0 Auto
{0 = All, 1 = Melee Only, 2 = Blocked}

;/
To access any of the bool variables from an OnHit event, use the following:
bool abHitBlocked = ((numArg as int) % 2) as bool
bool abPowerAttack = ((numArg as int) % 4) >= 1
bool abBashAttack = ((numArg as int) % 8) >= 1
bool abPowerAttack = numArg >= 8.0
/;

Function Initialize()
	RegisterForModEvent("SPE_HardcoreOn", "OnHardcoreEnable")
	RegisterForModEvent("SPE_HardcoreOff", "OnHardcoreDisable")
	If ProcMode == 1
		RegisterForModEvent("SPE_OnMeleeHitEvent", "OnHitProc")
	ElseIf ProcMode == 2
		RegisterForModEvent("SPE_OnBlockedHitEvent", "OnHitProc")
	Else
		RegisterForModEvent("SPE_OnHitEvent", "OnHitProc")
	EndIf
	If SPEHardcoreMode.GetValue() == 1
		Chance = ProcChanceHC
		Proc = ProcSpellHC
	Else
		Chance = ProcChance
		Proc = ProcSpell
	EndIf
EndFunction

Function OnHardcoreEnable(string eventName, string strArg, float numArg, Form sender)
	Chance = ProcChanceHC
	Proc = ProcSpellHC
EndFunction

Function OnHardcoreDisable(string eventName, string strArg, float numArg, Form sender)
	Chance = ProcChance
	Proc = ProcSpell
EndFunction

Function OnHitProc(string eventName, string strArg, float numArg, Form sender)
	If Utility.RandomInt(1,100) <= Chance
		ApplyProc(sender as Actor)
	EndIf
EndFunction

Function ApplyProc(Actor Attacker)
	If SelfCast == true
		Proc.Cast(PlayerRef)
	Else
		PlayerRef.DoCombatSpellApply(Proc, Attacker)
	EndIf
EndFunction