Scriptname SPEPerksScript extends Quest
{Executes script blocks when external abilities register with it.}

;Misc/Shared
Faction Property PlayerFaction Auto
GlobalVariable Property SPEUninstall Auto
Perk Property SPESurvivalist Auto
Perk Property SPECalmingPresence Auto
Actor Property PlayerRef Auto

;Alchemy
FormList Property SPESurgeonDeathItemList Auto
FormList Property SPESurgeonLootList Auto

;Alteration
FormList Property SPEArmorSpellAbilities Auto
FormList Property SPEAASpells Auto
FormList Property SPEAARaces Auto
GlobalVariable Property SPECustomAARace Auto
GlobalVariable Property SPEUseCustomAARace Auto

;Archery
Faction Property BearFaction Auto
Faction Property DogFaction Auto
Faction Property HorkerFaction Auto
Faction Property SabreCatFaction Auto
Faction Property SlaughterfishFaction Auto
Faction Property SprigganFaction Auto
Faction Property WolfFaction Auto

;Illusion
Faction Property GiantFaction Auto
Faction Property IceWraithFaction Auto
Faction Property MammothFaction Auto
Faction Property TrollFaction Auto
GlobalVariable Property PerkDaedricMind Auto

;Lockpicking
Faction Property ChaurusFaction Auto
Faction Property SkeeverFaction Auto
Faction Property SpiderFaction Auto
Faction Property DwarvenAutomatonFaction Auto
GlobalVariable Property PerkGoldenTouch Auto
GlobalVariable Property SpecialLootChance Auto
Quest Property SPELaunderQuest Auto
Quest Property SPEKeeningQuest Auto

;Smithing
Faction Property OrcFriendFaction Auto

;Speech
GlobalVariable Property PerkMasterTrader Auto
GlobalVariable Property SpeechEasy Auto
GlobalVariable Property SpeechAverage Auto
GlobalVariable Property SpeechHard Auto
GlobalVariable Property SpeechVeryHard Auto
Quest Property PerkInvestor Auto
SPEBestFriendQuestScript Property BestFriendQuest Auto
LeveledItem Property SPEPSStoreUpgrade Auto
LeveledItem Property SPEPPStoreUpgrade Auto
LeveledItem Property PerkInvestorMarkarthMagicList Auto
LeveledItem Property PerkInvestorRiftenMagicList Auto
LeveledItem Property PerkInvestorSolitudeMagicList Auto
LeveledItem Property PerkInvestorWhiterunMagicList Auto
LeveledItem Property PerkInvestorWindhelmMagicList Auto
LeveledItem Property PerkInvestorDawnstarApothecaryList Auto
LeveledItem Property PerkInvestorMarkarthApothecaryList Auto
LeveledItem Property PerkInvestorMorthalApothecaryList Auto
LeveledItem Property PerkInvestorRiftenApothecaryList Auto
LeveledItem Property PerkInvestorSolitudeApothecaryList Auto
LeveledItem Property PerkInvestorWhiterunApothecaryList Auto
LeveledItem Property PerkInvestorWindhelmApothecaryList Auto

Function UpdatePerk(string SkillName, string PerkName, bool EnablePerk = true)

	;check special cases first, since they're the most numerous
	If SkillName == ""
		If PerkName == "WeaponSpeedPerk" ;catch-all name for several perks affecting weapon speed
			(self as Quest).SendModEvent("SPE_UpdateHaste")
		ElseIf PerkName == "GameSettingPerk" ;perks that modify game settings
			(self as Quest).SendModEvent("SPE_UpdateGameSettings")
		EndIf
			
	;now check by perk tree, starting with the trees that have the most perks to check
	ElseIf SkillName == "Speech"
		If PerkName == "Master Trader"
			If EnablePerk
				PerkMasterTrader.SetValue(0)
			Else
				PerkMasterTrader.SetValue(100)
			EndIf
		ElseIf PerkName == "Convincing"
			If EnablePerk
				SpeechEasy.SetValue(SpeechEasy.GetValue() * 0.7)
				SpeechAverage.SetValue(SpeechAverage.GetValue() * 0.7)
				SpeechHard.SetValue(SpeechHard.GetValue() * 0.7)
				SpeechVeryHard.SetValue(SpeechVeryHard.GetValue() * 0.7)
			Else
				SpeechEasy.SetValue(25)
				SpeechAverage.SetValue(50)
				SpeechHard.SetValue(75)
				SpeechVeryHard.SetValue(100)
			EndIf
		ElseIf PerkName == "Investor"
			If EnablePerk
				PerkInvestor.SetStage(10)
			Else
				PerkInvestor.Reset()
				PerkInvestor.Stop()
			EndIf
		ElseIf PerkName == "Best Friend"
			If EnablePerk
				BestFriendQuest.Start()
				BestFriendQuest.SetPet()
			Else
				BestFriendQuest.RemovePet()
			EndIf
		ElseIf PerkName == "Patron"
			If EnablePerk
				PerkInvestorMarkarthMagicList.AddForm(SPEPSStoreUpgrade, 2, 1)
				PerkInvestorRiftenMagicList.AddForm(SPEPSStoreUpgrade, 2, 1)
				PerkInvestorSolitudeMagicList.AddForm(SPEPSStoreUpgrade, 2, 1)
				PerkInvestorWhiterunMagicList.AddForm(SPEPSStoreUpgrade, 2, 1)
				PerkInvestorWindhelmMagicList.AddForm(SPEPSStoreUpgrade, 2, 1)
				PerkInvestorDawnstarApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorMarkarthApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorMorthalApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorRiftenApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorSolitudeApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorWhiterunApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
				PerkInvestorWindhelmApothecaryList.AddForm(SPEPPStoreUpgrade, 2, 1)
			Else
				PerkInvestorMarkarthMagicList.Revert()
				PerkInvestorRiftenMagicList.Revert()
				PerkInvestorSolitudeMagicList.Revert()
				PerkInvestorWhiterunMagicList.Revert()
				PerkInvestorWindhelmMagicList.Revert()
				PerkInvestorDawnstarApothecaryList.Revert()
				PerkInvestorMarkarthApothecaryList.Revert()
				PerkInvestorMorthalApothecaryList.Revert()
				PerkInvestorRiftenApothecaryList.Revert()
				PerkInvestorSolitudeApothecaryList.Revert()
				PerkInvestorWhiterunApothecaryList.Revert()
				PerkInvestorWindhelmApothecaryList.Revert()
			EndIf
		ElseIf PerkName == "Master Debater"
			If EnablePerk
				PlayerRef.SetAV("Magicka", PlayerRef.GetBaseAV("Magicka") + 50)
			Else
				PlayerRef.SetAV("Magicka", PlayerRef.GetBaseAV("Magicka") - 50)
			EndIf
		EndIf

	ElseIf SkillName == "Lockpicking"
		If PerkName == "Dungeon Delver"
			If EnablePerk
				ChaurusFaction.SetAlly(PlayerFaction, true, true)
				SkeeverFaction.SetAlly(PlayerFaction, true, true)
				SpiderFaction.SetAlly(PlayerFaction, true, true)
			Else
				ChaurusFaction.SetEnemy(PlayerFaction, true, true)
				SkeeverFaction.SetEnemy(PlayerFaction, true, true)
				SpiderFaction.SetEnemy(PlayerFaction, true, true)
			EndIf
		ElseIf PerkName == "Dwemer Engineer"
			If EnablePerk
				DwarvenAutomatonFaction.SetAlly(PlayerFaction, true, true)
				SPEKeeningQuest.SetStage(10)
			Else
				DwarvenAutomatonFaction.SetEnemy(PlayerFaction, true, true)
			EndIf
		ElseIf PerkName == "Luck"
			If EnablePerk
				PerkGoldenTouch.SetValue(0)
			Else
				PerkGoldenTouch.SetValue(100)
			EndIf
		ElseIf PerkName == "Seeker"
			If EnablePerk
				SpecialLootChance.SetValue(85)
			Else
				SpecialLootChance.SetValue(90)
			EndIf
		ElseIf PerkName == "Inside Man"
			If EnablePerk
				SPELaunderQuest.SetStage(10)
			Else
				SPELaunderQuest.SetStage(400)
			EndIf
		EndIf

	ElseIf SkillName == "ALTERATION" ;magic skill names insist on being in all caps. I have no idea why.
		If PerkName == "Ancestral Awakening"
			If EnablePerk
				int index = SPEAARaces.Find(PlayerRef.GetRace())
				If index < 0 || SPEUseCustomAARace.GetValue() == 1
					index = SPECustomAARace.GetValue() as int * 2
				EndIf
				If index % 2 == 1
					index -= 1
				EndIf
				PlayerRef.AddSpell(SPEAASpells.GetAt(index) as Spell, false)
				PlayerRef.AddSpell(SPEAASpells.GetAt(index + 1) as Spell, false)
			Else
				int index = SPEAASpells.GetSize()
				While index > 0
					index -= 1
					PlayerRef.RemoveSpell(SPEAASpells.GetAt(index) as Spell)
				EndWhile
			EndIf
		ElseIf PerkName == "Mage Armor"
			If EnablePerk == false ;strip current armor spell after losing the perk
				int i = SPEArmorSpellAbilities.GetSize()
				While (i > 0)
					i -= 1
					PlayerRef.RemoveSpell(SPEArmorSpellAbilities.GetAt(i) as Spell)
				EndWhile
			EndIf
		EndIf

	ElseIf SkillName == "ILLUSION"
		If PerkName == "Calming Presence"
			If EnablePerk
				GiantFaction.SetAlly(PlayerFaction, true, true)
				IceWraithFaction.SetAlly(PlayerFaction, true, true)
				MammothFaction.SetAlly(PlayerFaction, true, true)
				TrollFaction.SetAlly(PlayerFaction, true, true)
			Else
				GiantFaction.SetEnemy(PlayerFaction, true, true)
				IceWraithFaction.SetEnemy(PlayerFaction, true, true)
				MammothFaction.SetEnemy(PlayerFaction, true, true)
				TrollFaction.SetEnemy(PlayerFaction, true, true)
			EndIf
		ElseIf PerkName == "Master Of The Mind"
			If EnablePerk
				PerkDaedricMind.SetValue(1)
			Else
				PerkDaedricMind.SetValue(0)
			EndIf
		EndIf

	ElseIf SkillName == "Archery"
		If PerkName == "Survivalist"
			If EnablePerk
				BearFaction.SetAlly(PlayerFaction, true, true)
				DogFaction.SetAlly(PlayerFaction, true, true)
				HorkerFaction.SetAlly(PlayerFaction, true, true)
				SabreCatFaction.SetAlly(PlayerFaction, true, true)
				SlaughterfishFaction.SetAlly(PlayerFaction, true, true)
				SprigganFaction.SetAlly(PlayerFaction, true, true)
				WolfFaction.SetAlly(PlayerFaction, true, true)
			Else
				BearFaction.SetEnemy(PlayerFaction, true, true)
				DogFaction.SetEnemy(PlayerFaction, true, true)
				HorkerFaction.SetEnemy(PlayerFaction, true, true)
				SabreCatFaction.SetEnemy(PlayerFaction, true, true)
				SlaughterfishFaction.SetEnemy(PlayerFaction, true, true)
				SprigganFaction.SetEnemy(PlayerFaction, true, true)
				WolfFaction.SetEnemy(PlayerFaction, true, true)
			EndIf
		EndIf

	ElseIf SkillName == "CONJURATION"
		If PerkName == "Summoner"
			If EnablePerk
				PlayerRef.SetAV("Health", PlayerRef.GetBaseAV("Health") + 50)
			Else
				PlayerRef.SetAV("Health", PlayerRef.GetBaseAV("Health") - 50)
			EndIf
		EndIf

	ElseIf SkillName == "Pickpocket"
		If PerkName == "Extra Pockets"
			If EnablePerk
				PlayerRef.SetAV("Stamina", PlayerRef.GetBaseAV("Stamina") + 50)
			Else
				PlayerRef.SetAV("Stamina", PlayerRef.GetBaseAV("Stamina") - 50)
			EndIf
		EndIf

	ElseIf SkillName == "Alchemy"
		If PerkName == "Surgeon"
			If EnablePerk
				(self as Quest).SendModEvent("SPE_SurgeonActive") ;activate the potion watch script
				int i = SPESurgeonDeathItemList.GetSize()
				While i > 0
					i -= 1
					(SPESurgeonDeathItemList.GetAt(i) as LeveledItem).AddForm(SPESurgeonLootList.GetAt(i), 1, 1)
				EndWhile
			Else
				int i = SPESurgeonDeathItemList.GetSize()
				While i > 0
					i -= 1
					(SPESurgeonDeathItemList.GetAt(i) as LeveledItem).Revert()
				EndWhile
			EndIf
		EndIf

	ElseIf SkillName == "Smithing"
		If PerkName == "Honorary Orc"
			If EnablePerk
				PlayerRef.AddtoFaction(OrcFriendFaction)
			Else
				;too many complications would be caused by removing from the faction, so just leave it.
			EndIf
		EndIf

	;currently unused skills
	;ElseIf SkillName == "HeavyArmor"
	;ElseIf SkillName == "Sneak"
	;ElseIf SkillName == "Block"
	;ElseIf SkillName == "OneHanded"
	;ElseIf SkillName == "TwoHanded"
	;ElseIf SkillName == "LightArmor"
	;ElseIf SkillName == "Enchanting"
	;ElseIf SkillName == "DESTRUCTION"
	;ElseIf SkillName == "RESTORATION"

	EndIf
EndFunction
