Scriptname SPEPhantomBeastScript extends Actor  
{Manages damage and death report for phantom beasts. Also occasionally has them cast a fear spell.}

SPESummonManagerScript Property SPESummonQuest Auto
int Property baseDamage Auto
Spell Property SPEPhantomBeastFear01 Auto
Spell Property SPEPhantomBeastFear02 Auto
Spell Property SPEPhantomBeastFear03 Auto
Actor Property PlayerRef Auto

Event OnLoad()
	SetAV("UnarmedDamage", baseDamage)
	SetAV("Illusion", PlayerRef.GetAV("Illusion"))
	RegisterForSingleUpdate(5)
EndEvent

Event OnDying(Actor akKiller)
	If akKiller 
		SPESummonQuest.BeastDied()
	Else
		SPESummonQuest.BeastUnsummoned()
	EndIf
EndEvent

Event OnUpdate()
	Actor Target = GetCombatTarget()
	If Target != NONE
		If Target == PlayerRef
			Kill() ;don't bite the hand that feeds you
		ElseIf GetDistance(Target) < 600 && Utility.RandomInt(1,20) == 1
			If PlayerRef.GetAV("Illusion") == 100
				SPEPhantomBeastFear03.Cast(self, Target)
				Game.AdvanceSkill("Illusion", 118.25)
			ElseIf PlayerRef.GetAV("Illusion") >= 75
				SPEPhantomBeastFear02.Cast(self, Target)
				Game.AdvanceSkill("Illusion", 92.5)
			Else
				SPEPhantomBeastFear01.Cast(self, Target)
				Game.AdvanceSkill("Illusion", 38.25)
			EndIf
		EndIf
	EndIf
	RegisterForSingleUpdate(5)
EndEvent
