Scriptname SPEPreserverScript extends ActiveMagicEffect
{Allows soul gems / souls to randomly remain after use.}

GlobalVariable Property SPEHardcoreMode Auto
FormList Property SPESoulGemsEmpty Auto
FormList Property SPESoulGemsFilled Auto

int Property KeepChance = 50 Auto
{Percent chance a soul gem will remain after use.}

int Property FilledChance = 50 Auto
{Percent chance the soul gem stays filled.}

Event OnEffectStart(Actor akTarget, Actor akCaster)
	AddInventoryEventFilter(SPESoulGemsFilled)
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If aiItemCount == 1 && akItemReference == NONE && akDestContainer == NONE ;a single gem has vanished, probably from use
		If SPEHardcoreMode.GetValue() == 0
			If Utility.RandomInt(1, 100) <= KeepChance ;whether or not the gem stays
				If Utility.RandomInt(1,100) <= FilledChance ;whether or not the soul stays
					GetTargetActor().AddItem(akBaseItem, 1, true)
				Else
					GetTargetActor().AddItem(SPESoulGemsEmpty.GetAt(SPESoulGemsFilled.Find(akBaseItem)) as SoulGem, 1, true)
				EndIf
			EndIf
		Else ;hardcore mode, random chances are reduced
			If Utility.RandomInt(1, 100) <= (KeepChance / 2)
				If Utility.RandomInt(1,100) <= (FilledChance / 2)
					GetTargetActor().AddItem(akBaseItem, 1, true)
				Else
					GetTargetActor().AddItem(SPESoulGemsEmpty.GetAt(SPESoulGemsFilled.Find(akBaseItem)) as SoulGem, 1, true)
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent