Scriptname SPEProspectorScript extends SPEPlayerOnlyAbility
{Increases the yield of mining.}

Keyword Property isPickaxeFloor Auto
Keyword Property isPickaxeTable Auto
Keyword Property isPickaxeWall Auto
Keyword Property VendorItemOreIngot Auto
Keyword Property VendorItemGem Auto
FormList Property MineOreToolsList Auto
Quest Property SPEProspectorMiningQuest Auto
ObjectReference Property OreChest Auto

int MiningToolsEquipped = 0

Function Initialize()
	CheckMiningList(PlayerRef.GetEquippedWeapon(true))
	CheckMiningList(PlayerRef.GetEquippedWeapon(false))
	CheckMiningList(PlayerRef.GetEquippedSpell(0))
	CheckMiningList(PlayerRef.GetEquippedSpell(1))
	CheckMiningList(PlayerRef.GetEquippedSpell(2))
	CheckMiningList(PlayerRef.GetEquippedSpell(3))
	CheckMiningList(PlayerRef.GetEquippedShout())
	If MiningToolsEquipped >= 1
		GoToState("ReadyToMine")
		RegisterForSingleUpdate(0)
	EndIf
EndFunction

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	SPEProspectorMiningQuest.Stop()
EndEvent

Function CheckMiningList(Form EquippedForm)
	If EquippedForm != NONE && MineOreToolsList.HasForm(EquippedForm)
		MiningToolsEquipped += 1
	EndIf
EndFunction

Event OnSit(ObjectReference akFurniture)
	If akFurniture.HasKeyword(isPickaxeFloor) || akFurniture.HasKeyword(isPickaxeTable) || akFurniture.HasKeyword(isPickaxeWall)
		GoToState("Mining")
	EndIf
EndEvent

Event OnGetUp(ObjectReference akFurniture)
	GoToState("")
	OreChest.RemoveAllItems(PlayerRef)
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If MineOreToolsList.HasForm(akBaseObject)
		MiningToolsEquipped += 1
		GoToState("ReadyToMine")
		RegisterForModEvent("SPE_OreHit", "OreHit")
		RegisterForSingleUpdate(0)
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If MineOreToolsList.HasForm(akBaseObject)
		MiningToolsEquipped -= 1
		If MiningToolsEquipped < 0
			MiningToolsEquipped = 0
		EndIf
		If MiningToolsEquipped == 0
			GoToState("")
			UnregisterForModEvent("SPE_OreHit")
			SPEProspectorMiningQuest.Stop()
			UnregisterForUpdate()
		EndIf
	EndIf
EndEvent

Event OnUpdate()
	UnregisterForUpdate()
	SPEProspectorMiningQuest.Stop()
EndEvent

Function OreHit(string eventName, string strArg, float numArg, Form sender)
	;do nothing unless player is mining
EndFunction

;create hidden chest, add stuff after

State Mining
	Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
		If akBaseItem.HasKeyword(VendorItemOreIngot) || akBaseItem.HasKeyword(VendorItemGem)
			;GoToState("Adding")
			OreChest.AddItem(akBaseItem, aiItemCount) ;, true)
			;GoToState("Mining")
		EndIf
	EndEvent
	
	Event OnUpdate()
		GoToState("ReadyToMine")
		OreChest.RemoveAllItems(PlayerRef)
		RegisterForSingleUpdate(1)
	EndEvent
	
	Function OreHit(string eventName, string strArg, float numArg, Form sender)
		RegisterForSingleUpdate(0.5)
	EndFunction
EndState

State ReadyToMine
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
		If MineOreToolsList.HasForm(akBaseObject)
			MiningToolsEquipped += 1
		EndIf
	EndEvent
	
	Event OnUpdate()
		;pulse the quest so it grabs the nearest ore to watch for mining hits
		SPEProspectorMiningQuest.Stop()
		SPEProspectorMiningQuest.Start()
		RegisterForSingleUpdate(5)
	EndEvent	

	Function OreHit(string eventName, string strArg, float numArg, Form sender)
		GoToState("Mining")
		RegisterForSingleUpdate(0.5)
		;GoToState("ReadyToMine")
	EndFunction
EndState