Scriptname SPEQuestCredit extends Quest  
{A script to reward the player with a free skill point upon completing a quest.}

int questsCompleted
string[] skillsArray
GlobalVariable Property SPEQuestRewards Auto
Actor Property PlayerRef Auto

EVENT OnInit()
	questsCompleted = Game.QueryStat("Quests Completed")
	skillsArray = new string[18]
	skillsArray[0] = "Alchemy"
	skillsArray[1] = "Alteration"
	skillsArray[2] = "Marksman"
	skillsArray[3] = "Block"
	skillsArray[4] = "Conjuration"
	skillsArray[5] = "Destruction"
	skillsArray[6] = "Enchanting"
	skillsArray[7] = "HeavyArmor"
	skillsArray[8] = "Illusion"
	skillsArray[9] = "LightArmor"
	skillsArray[10] = "Lockpicking"
	skillsArray[11] = "OneHanded"
	skillsArray[12] = "Pickpocket"
	skillsArray[13] = "Restoration"
	skillsArray[14] = "Smithing"
	skillsArray[15] = "Sneak"
	skillsArray[16] = "Speechcraft"
	skillsArray[17] = "TwoHanded"
	RegisterForSingleUpdate(5)
endEVENT

Event OnUpdate()
	If SPEQuestRewards.GetValue()
		If Game.QueryStat("Quests Completed") > questsCompleted
			questsCompleted = questsCompleted + 1
			statReward()
		EndIf
	EndIf
	RegisterForSingleUpdate(5)
endEvent

Function statReward()
	string[] skillNames = new string[5]
	int[] skillValues = new int[5]
	int i = 0
	int currentValue
	While(i < 18) ;this loop populates the skillNames array with the top five non-maxed skills
		currentValue = PlayerRef.GetBaseAV(skillsArray[i]) as int
		If currentValue < 100 ;Ignore any skill already at max.		
			If currentValue > skillValues[0] ;If the new value is the largest
				skillValues[4] = skillValues[3] ;shift other values down
				skillValues[3] = skillValues[2]
				skillValues[2] = skillValues[1]
				skillValues[1] = skillValues[0]
				skillValues[0] = currentValue ;and put the new largest value at the top
				skillNames[4] = skillNames[3]
				skillNames[3] = skillNames[2]
				skillNames[2] = skillNames[1]
				skillNames[1] = skillNames[0]
				skillNames[0] = skillsArray[i]
			ElseIf currentValue > skillValues[1] ;If it's the second largest...
				skillValues[4] = skillValues[3]
				skillValues[3] = skillValues[2]
				skillValues[2] = skillValues[1]
				skillValues[1] = currentValue
				skillNames[4] = skillNames[3]
				skillNames[3] = skillNames[2]
				skillNames[2] = skillNames[1]
				skillNames[1] = skillsArray[i]
			ElseIf currentValue > skillValues[2]
				skillValues[4] = skillValues[3]
				skillValues[3] = skillValues[2]
				skillValues[2] = currentValue
				skillNames[4] = skillNames[3]
				skillNames[3] = skillNames[2]
				skillNames[2] = skillsArray[i]
			ElseIf currentValue > skillValues[3]
				skillValues[4] = skillValues[3]
				skillValues[3] = currentValue
				skillNames[4] = skillNames[3]
				skillNames[3] = skillsArray[i]
			ElseIf currentValue > skillValues[4]
				skillValues[4] = currentValue
				skillNames[4] = skillsArray[i]
			EndIf
		EndIf
		i += 1
	EndWhile
	
	;this chunk actually awards the skill point
	If (skillNames[4] != "") ;make sure the skillNames array is full
		Game.IncrementSkill(skillNames[Utility.RandomInt(0,4)])
	ElseIf (skillNames[3] != "") ;if it's not full, pick from what's there
		Game.IncrementSkill(skillNames[Utility.RandomInt(0,3)])
	ElseIf (skillNames[2] != "")
		Game.IncrementSkill(skillNames[Utility.RandomInt(0,2)])
	ElseIf (skillNames[1] != "")
		Game.IncrementSkill(skillNames[Utility.RandomInt(0,1)])
	ElseIf (skillNames[0] != "") ;make sure there's at least one skill to increase, otherwise do nothing
		Game.IncrementSkill(skillNames[0])
	EndIf
	
EndFunction
