Scriptname SPESpellChargeManager extends SPEPlayerOnlyAbility
{Adds spell charge buffs as the player continues charging.}

Spell Property SPEPerkSpellChargeAb01 Auto
Spell Property SPEPerkSpellChargeAb02 Auto
Spell Property SPEPerkSpellChargeAb03 Auto
Spell Property SPEPerkSpellChargeFXAb Auto
GlobalVariable Property SPEIsDualCasting Auto
EffectShader Property EnchBlueFXShader auto
bool Casting = true
int CastStage = 0
bool SpellCast = false

Function Initialize()
	RegisterForModEvent("SPE_CastStart", "OnCastStart")
	RegisterForModEvent("SPE_CastStop", "OnCastStop")
EndFunction

Event OnSpellCast(Form akSpell)
	EnchBlueFXShader.Stop(PlayerRef)
	SpellCast = true
	RegisterForSingleUpdate(1) ;wait to remove buffs so they have a chance to affect projectile spells
EndEvent

Event OnUpdate()
	If SpellCast == true ;process the effect end after a successful cast
		SpellCast = false
		RemoveBuffs()
		CastStage = 0
		If Casting == true ;player is casting repeatedly, so continue advancing stages
			StageUp()
		EndIf
	ElseIf Casting == true
		StageUp()
	Else ;this shouldn't fire, but just in case, don't leave the buffs hanging around
		RemoveBuffs()
	EndIf
EndEvent

Function RemoveBuffs()
		PlayerRef.RemoveSpell(SPEPerkSpellChargeAb01)
		PlayerRef.RemoveSpell(SPEPerkSpellChargeAb02)
		PlayerRef.RemoveSpell(SPEPerkSpellChargeAb03)
		EnchBlueFXShader.Stop(PlayerRef)
EndFunction

Function StageUp() ;manage staged buffs
	If SPEIsDualCasting.GetValue() == 0 && (CastStage < 3) ;don't add buffs if dual casting
		If CastStage == 0
			PlayerRef.AddSpell(SPEPerkSpellChargeAb01, false)
		ElseIf CastStage == 1
			PlayerRef.AddSpell(SPEPerkSpellChargeAb02, false)
		ElseIf CastStage == 2
			PlayerRef.AddSpell(SPEPerkSpellChargeAb03, false)
			EnchBlueFXShader.Play(PlayerRef)
		EndIf
		CastStage += 1
	EndIf
	RegisterForSingleUpdate(1)
EndFunction

Function OnCastStart(string eventName, string strArg, float numArg, Form sender)
	If PlayerRef	!= NONE ;make sure the alias is filled
		Casting = true
		If CastStage == 0 ;don't interrupt the script if it's still working
			RegisterForSingleUpdate(1)
		EndIf
	EndIf
EndFunction

Function OnCastStop(string eventName, string strArg, float numArg, Form sender)
	If PlayerRef != NONE ;make sure the alias is filled
		Casting = false
		If SpellCast == false ;did not cast the spell, just stopped casting
			UnregisterForUpdate()
			CastStage = 0
			RemoveBuffs()
		EndIf
	EndIf
EndFunction