Scriptname SPESpellRepeater extends activemagiceffect
{Rewrite of the 'cloak' type spell effect with more options.}

Spell Property SpellToRepeat Auto
GlobalVariable Property SPEBrawlMode Auto
SPEBrawlManager Property SPEBrawlQuest Auto
Actor Target

;options for how this effect should behave
int Property Interval = 3 Auto ;how often (in seconds) to cast the effect
bool Property CombatOnly = true Auto ;only cast this effect when in combat
bool Property CastOnStart = true Auto ;cast this spell as soon as the effect begins instead of waiting one interval
bool Property RandomInterval = false Auto ;adds variation to how often the effect fires
Int Property IntervalMin = 3 Auto ;random interval: minimum time (in seconds) between re-casts
Int Property IntervalMax = 6 Auto ;random interval: maximum time (in seconds) between re-casts
bool Property RandomChance = false Auto ;adds a random chance to skip casting the spell
Int Property CastChance = 30 Auto ;The chance that the spell will cast successfully

Event OnEffectStart(Actor akTarget, Actor akCaster)
	Target = akTarget
	If CastOnStart
		CastSpell()
	ElseIf !CombatOnly || Target.IsInCombat()
		Delay()
	Else
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Event OnUpdate()
	If Target != NONE
		CastSpell()
	EndIf
EndEvent

Function CastSpell()
	If SPEBrawlMode.GetValue() == 1 ;poll during manual brawl mode
		RegisterForSingleUpdate(1)
	ElseIf !CombatOnly || Target.IsInCombat()
		If SPEBrawlQuest.CheckForBrawl() == 0 ;turn off for brawls
			If !RandomChance || Utility.RandomInt(1, 100) <= CastChance
				SpellToRepeat.Cast(Target)
			EndIf
			Delay()
		EndIf
	Else ;Should function only in combat, but actor isn't in combat.
		RegisterForSingleUpdate(1) ;poll more often to activate as soon as combat starts
	EndIf
EndFunction

Function Delay()
	If RandomInterval
		Interval = Utility.RandomInt(IntervalMin, IntervalMax)
	EndIf
	RegisterForSingleUpdate(Interval)
EndFunction