Scriptname SPEStaffLevelingScript extends SPEPlayerOnlyAbility
{Gives skill xp for staff use. Also can teach staff spells.}

FormList Property SPEStaffEnchantments Auto
FormList Property SPEStaffLearnedSpells Auto
int Property LearningThreshhold = 30 Auto ;player learns the spell after casting it this many times
float[] Property SkillXP Auto ;contains xp values for all spells
int[] LearnCounter ;keeps track of number of casts, to teach the spell when appropriate
Perk Property SPEArtificer Auto

int concIndex
bool casting = false

Function Initialize()
	RegisterForModEvent("SPE_CastStop", "OnCastStop")
	LearnCounter = new int[63] ;should be same size as staff enchantments
	SkillXP = new float[63]
	SetSkillXP()
EndFunction

Function OnCastStop(string eventName, string strArg, float numArg, Form sender)
	casting = false
EndFunction

Event OnSpellCast(Form akSpell)
	If akSpell as Enchantment
		int index = SPEStaffEnchantments.Find(akSpell)
		If index >= 0 ;found the spell
			If index <= 42
				If index >= 36 ;concentration spells
					concIndex = index
					casting = true
					RegisterForSingleUpdate(0)
				ElseIf index == 20 ;Magelight
					Game.AdvanceSkill("Alteration", SkillXP[index])
					LearnSpell(index)
				ElseIf PlayerRef.IsInCombat() ;everything else only goes up in combat
					If index >= 30 ;restoration spells
						Game.AdvanceSkill("Restoration", SkillXP[index])
					ElseIf index >= 22 ;destruction spells
						Game.AdvanceSkill("Destruction", SkillXP[index])
					ElseIf index == 21 ;Paralyze
						Game.AdvanceSkill("Alteration", SkillXP[index])
					ElseIf index >= 12 ;illusion spells
						Game.AdvanceSkill("Illusion", SkillXP[index])
					Else ;conjuration spells
						Game.AdvanceSkill("Conjuration", SkillXP[index])
					EndIf
					LearnSpell(index)
				EndIf
			ElseIf PlayerRef.HasPerk(SPEArtificer) ;higher numbers are artificer only spells
				If index >= 56 ;concentration spells
					concIndex = index
					casting = true
					RegisterForSingleUpdate(0)
				ElseIf PlayerRef.IsInCombat() ;the rest are combat only
					If index >= 53 ;restoration spells
						Game.AdvanceSkill("Restoration", SkillXP[index])
					ElseIf index >= 48 ;destruction spells
						Game.AdvanceSkill("Destruction", SkillXP[index])
					ElseIf index >= 44 ;illusion spells
						Game.AdvanceSkill("Illusion", SkillXP[index])
					Else ;Summon Dremora
						Game.AdvanceSkill("Conjuration", SkillXP[index])
					EndIf
					LearnSpell(index)
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent

Function SetSkillXP()
	
	;conjuration
	SkillXP[0] = 196 ;Banish Daedra
	SkillXP[1] = 242 ;Command Daedra
	SkillXP[2] = 75 ;Conjure Flame Atronach
	SkillXP[3] = 160.5 ;Conjure Frost Atronach
	SkillXP[4] = 322 ;Conjure Storm Atronach
	SkillXP[5] = 64.2 ;Conjure Familiar
	SkillXP[6] = 302 ;Dread Zombie
	SkillXP[7] = 215 ;Expel Daedra
	SkillXP[8] = 515 ;Raise Zombie
	SkillXP[9] = 432 ;Reanimate Corpse
	SkillXP[10] = 183 ;Revenant
	SkillXP[11] = 214 ;Soul Trap

	;illusion
	SkillXP[12] = 36.5 ;Calm
	SkillXP[13] = 39 ;Courage
	SkillXP[14] = 38.25 ;Fear
	SkillXP[15] = 104.5 ;Frenzy
	SkillXP[16] = 20.1 ;Fury
	SkillXP[17] = 72.5 ;Mass Charm
	SkillXP[18] = 33.9 ;Rally
	SkillXP[19] = 79 ;Rout

	;alteration
	SkillXP[20] = 12.6 ;Magelight
	SkillXP[21] = 450 ;Paralysis

	;destruction
	SkillXP[22] = 20 ;Chain Lightning
	SkillXP[23] = 20 ;Fireball
	SkillXP[24] = 25 ;Firebolt
	SkillXP[25] = 25 ;Ice Spike
	SkillXP[26] = 20 ;Ice Storm
	SkillXP[27] = 60 ;Icy Spear
	SkillXP[28] = 60 ;Incinerate
	SkillXP[29] = 25 ;Lightning Bolt

	;restoration
	SkillXP[30] = 115 ;Repel Lesser Undead
	SkillXP[31] = 353 ;Repel Undead
	SkillXP[32] = 266 ;Turn Greater Undead
	SkillXP[33] = 84 ;Turn Lesser Undead
	SkillXP[34] = 168 ;Turn Undead
	SkillXP[35] = 75 ;Heal Other
	
	;destruction conc
	SkillXP[36] = 8 ;Wall Of Flames
	SkillXP[37] = 8 ;Wall Of Frost
	SkillXP[38] = 8 ;Wall Of Storms
	SkillXP[39] = 8 ;Flames
	SkillXP[40] = 8 ;Frostbite
	SkillXP[41] = 8 ;Sparks
	
	;restoration conc
	SkillXP[42] = 10 ;Healing Hands
	
	;Artificer spells
	
	;Conjuration
	SkillXP[43] = 215 ;Summon Dremora
	
	;Illusion
	SkillXP[44] = 218 ;Haldir's Embrace
	SkillXP[45] = 77 ;Ice Terror
	SkillXP[46] = 115 ;Terror
	SkillXP[47] = 40 ;Waking Nightmare
	
	;Destruction
	SkillXP[48] = 25 ;Call Storm
	SkillXP[49] = 20 ;Dragonsbane
	SkillXP[50] = 30 ;Frostfeed
	SkillXP[51] = 45 ;Nightingale's Storm
	SkillXP[52] = 150 ;Wabbajack
	
	;Restoration
	SkillXP[53] = 15 ;Meridia's Light
	SkillXP[54] = 66 ;Red Eagle
	SkillXP[55] = 25 ;Silent Moons
	SkillXP[56] = 20 ;Will Of Magnus
	
	;Destruction conc
	SkillXP[57] = 25 ;Absorb Health
	SkillXP[58] = 30 ;Absorb Magicka
	SkillXP[59] = 50 ;Absorb Stamina
	SkillXP[60] = 24 ;Bloodthorn
	SkillXP[61] = 87 ;Soul Harvest
	SkillXP[62] = 50 ;Nightingale's Talon

EndFunction

Event OnUpdate()
	If casting
		RegisterForSingleUpdate(2)
		If concIndex == 42 ;healing hands
			If PlayerRef.GetAV("Health") < PlayerRef.GetBaseAV("Health")
				Game.AdvanceSkill("Restoration", SkillXP[concIndex])
				LearnSpell(concIndex)
			EndIf
		ElseIf PlayerRef.IsInCombat() ;the rest require combat
			If concIndex < 42 || concIndex > 56 ;destruction spells
				Game.AdvanceSkill("Destruction", SkillXP[concIndex])
			Else ;Staff of Magnus
				Game.AdvanceSkill("Restoration", SkillXP[concIndex])
			EndIf
			LearnSpell(concIndex)
		EndIf
	Else
		concIndex = 0
	EndIf
EndEvent

Function LearnSpell(int index)
	If !(PlayerRef.HasSpell(SPEStaffLearnedSpells.GetAt(index) as Spell)) ;no sense adding it twice
		LearnCounter[index] = LearnCounter[index] + 1
		If LearnCounter[index] >= LearningThreshhold
			PlayerRef.AddSpell(SPEStaffLearnedSpells.GetAt(index) as Spell)
		EndIf
	EndIf
EndFunction
