Scriptname SPEStatsScript extends SPEPlayerOnlyAbility
{Tracks player stats for use in various conditions.}

Function Initialize()
	RegisterForModEvent("SPE_SkillUp", "OnSkillUp")
EndFunction

;Cloak of Shadows & Dodge Perks

GlobalVariable Property SPEHardcoreMode Auto
GlobalVariable Property SPEPerkDodgeChance Auto
GlobalVariable Property SPEPerkCloakChance Auto

Function OnSkillUp(string eventName, string strArg, float numArg, Form sender)
	int Chance = (PlayerRef.GetAV("Sneak") * 0.1) as int
	If Chance > 10
		Chance = 10
	EndIf
	If SPEHardcoreMode.GetValue() == 1
		Chance /= 2
	EndIf
	SPEPerkCloakChance.SetValue(Chance)
	Chance = (PlayerRef.GetAV("Pickpocket") * 0.25) as int
	If Chance > 25
		Chance = 25
	EndIf
	If SPEHardcoreMode.GetValue() == 1
		Chance /= 2
	EndIf
	SPEPerkDodgeChance.SetValue(Chance)
EndFunction

;Impact Perk

GlobalVariable Property SPEPerkImpactMagickaPercent Auto

Event OnSpellCast(Form akSpell)
	SPEPerkImpactMagickaPercent.SetValue(PlayerRef.GetAVPercentage("Magicka"))
EndEvent

;Armor Experience

GlobalVariable Property SPEHeavyPieces Auto
GlobalVariable Property SPELightPieces Auto
Keyword Property ArmorHeavy Auto
Keyword Property ArmorLight Auto
Spell Property SPEArmorCountAb Auto
MagicEffect Property SPEArmorCountH01 Auto
MagicEffect Property SPEArmorCountH02 Auto
MagicEffect Property SPEArmorCountH03 Auto
MagicEffect Property SPEArmorCountH04 Auto
MagicEffect Property SPEArmorCountH05 Auto
MagicEffect Property SPEArmorCountL01 Auto
MagicEffect Property SPEArmorCountL02 Auto
MagicEffect Property SPEArmorCountL03 Auto
MagicEffect Property SPEArmorCountL04 Auto
MagicEffect Property SPEArmorCountL05 Auto


Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject.HasKeyword(ArmorHeavy)
		SPEHeavyPieces.value += 1
	ElseIf akBaseObject.HasKeyword(ArmorLight)
		SPELightPieces.value += 1
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If akBaseObject.HasKeyword(ArmorHeavy)
		SPEHeavyPieces.value -= 1
	ElseIf akBaseObject.HasKeyword(ArmorLight)
		SPELightPieces.value -= 1
	EndIf
EndEvent

Event OnPlayerLoadGame()
	CountArmorPieces()
EndEvent

Function CountArmorPieces()
	PlayerRef.AddSpell(SPEArmorCountAb, false)
	If PlayerRef.HasMagicEffect(SPEArmorCountH01)
		SPEHeavyPieces.value = 1
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountH02)
		SPEHeavyPieces.value = 2
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountH03)
		SPEHeavyPieces.value = 3
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountH04)
		SPEHeavyPieces.value = 4
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountH05)
		SPEHeavyPieces.value = 5
	Else
		SPEHeavyPieces.value = 0
	EndIf
	If PlayerRef.HasMagicEffect(SPEArmorCountL01)
		SPELightPieces.value = 1
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountL02)
		SPELightPieces.value = 2
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountL03)
		SPELightPieces.value = 3
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountL04)
		SPELightPieces.value = 4
	ElseIf PlayerRef.HasMagicEffect(SPEArmorCountL05)
		SPELightPieces.value = 5
	Else
		SPELightPieces.value = 0
	EndIf
	PlayerRef.RemoveSpell(SPEArmorCountAb)
EndFunction