Scriptname SPESunderScript extends ActiveMagicEffect  
{"Breaks" an equipped piece of armor at random.}

Keyword Property ArmorCuirass  Auto  
Keyword Property ArmorGauntlets  Auto  
Keyword Property ArmorHelmet  Auto  
Armor Property SPEDummyArmorBody  Auto  
Armor Property SPEDummyArmorHead  Auto  
Armor Property SPEDummyArmorHands  Auto  
Sound Property SPESunderSound Auto
int gauntlets = 0
int helmet = 0
int cuirass = 0

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	GetTargetActor().RemoveItem(akBaseObject, 1)
EndEvent

Event OnEffectStart(Actor akTarget, Actor akCaster)
	If !Game.GetPlayer().IsInKillMove()
		int soundEffect = SPESunderSound.Play(GetTargetActor())
		Sound.SetInstanceVolume(soundEffect, 2.0)
		If akTarget.WornHasKeyword(ArmorGauntlets)
			gauntlets = Utility.RandomInt(1,6)
		EndIf
		If akTarget.WornHasKeyword(ArmorHelmet)
			helmet = Utility.RandomInt(1,6)
		EndIf
		If akTarget.WornHasKeyword(ArmorCuirass)
			cuirass = Utility.RandomInt(1,5)
		EndIf
		If (gauntlets >= helmet) && (gauntlets >= cuirass)
			breakArmor(SPEDummyArmorHands)
		ElseIf (helmet >= cuirass)
			breakArmor(SPEDummyArmorHead)
		Else
			breakArmor(SPEDummyArmorBody)
		EndIf
	EndIf
EndEvent

Function breakArmor(Armor dummyPiece)
	GetTargetActor().AddItem(dummyPiece, 1)
	GetTargetActor().EquipItem(dummyPiece, true, true)
	Utility.Wait(0.1)
	GetTargetActor().RemoveItem(dummyPiece, 1)
EndFunction
