Scriptname SPESurgeonScript extends SPEPlayerOnlyAbility
{Raises primary stats when the player drinks a special perk potion.}

Keyword Property SPESurgeonPotionKeyword Auto
Keyword Property SPESurgeonHealthKeyword Auto
Keyword Property SPESurgeonMagickaKeyword Auto
Keyword Property SPESurgeonStaminaKeyword Auto
Message Property SPESurgeonHealthGainMessage Auto
Message Property SPESurgeonMagickaGainMessage Auto
Message Property SPESurgeonStaminaGainMessage Auto

int HealthGain = 6
int MagickaGain = 6
int StaminaGain = 6

Function Initialize()
	RegisterForModEvent("SPE_SurgeonActive", "StartPotionChecks") ;script does nothing until perk is taken
EndFunction

Function StartPotionChecks(string eventName, string strArg, float numArg, Form sender)
	If HealthGain > 0 || MagickaGain > 0 || StaminaGain > 0 ;don't activate if stat gains are maxed
		GoToState("Active") ;watch for potions
	EndIf
EndFunction

State Active
	Event OnSpellCast(Form akSpell)
		If akSpell as Potion && akSpell.HasKeyword(SPESurgeonPotionKeyword) ;drank perk potion
			If akSpell.HasKeyword(SPESurgeonStaminaKeyword)
				If StaminaGain > 0
					PlayerRef.SetAV("Stamina", PlayerRef.GetBaseAV("Stamina") + StaminaGain)
					SPESurgeonStaminaGainMessage.Show(StaminaGain)
					StaminaGain -= 1
				EndIf
			ElseIf akSpell.HasKeyword(SPESurgeonMagickaKeyword)
				If MagickaGain > 0
					PlayerRef.SetAV("Magicka", PlayerRef.GetBaseAV("Magicka") + MagickaGain)
					SPESurgeonMagickaGainMessage.Show(MagickaGain)
					MagickaGain -= 1
				EndIf
			Else
				If HealthGain > 0
					PlayerRef.SetAV("Health", PlayerRef.GetBaseAV("Health") + HealthGain)
					SPESurgeonHealthGainMessage.Show(HealthGain)
					HealthGain -= 1
				EndIf
			EndIf
			If HealthGain <= 0 && MagickaGain <= 0 && StaminaGain <= 0 ;all stats gained
				GoToState("") ;no need to keep watching potions
			EndIf
		EndIf
	EndEvent
EndState